#include <vcl.h>                                 //Include vcl.h
#pragma hdrstop
#include "cdutils.h"                             //Include cdutils.h
#include "Server2.h"                             //Include Server2.h
#include "About.h"                               //Include About.h
#include "City.h"                                //Include City.h
#include "SoundF.h"
#pragma package(smart_init)
#pragma link "AEngine7"
#pragma link "AWaveSound2"
#pragma link "E7_DDraw"
#pragma resource "*.dfm"
TMainForm *MainForm;
//Form Functions-------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
  int i;

  DDDestroySurface(lpDDS_Screen);                //Destroy Screen Surface
  for (i = 1; i < TotPics; i++)
   DDDestroySurface(lpDDS[i]);                   //Destroy Buildings
  for (i = 1; i < 5; i++)
   DDDestroySurface(lpDDS_Cursor[i]);            //Destroy Cursors
  CDClose();                                     //Close CD player
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  int C;                                         //Counting int
  int XC, YC;                                    //X and Y Counters
  int MapX = 0, MapY = 0;                        //Map Counters
  bool Swap = true;                              //Swap
  AnsiString Pic;                                //Picture name
  IPoint ISize;                                  //Image Size

  randomize();                                   //Randomize timer
  Server(S2_Init(), true, true);                 //Initialise 2nd Server
  Server("GET_LOCATION;", true, true);

  for (C = 1; C < TotPics; C++) Req[C].Sprite = 0;
  Server("EXEC; City.ini;", true, true);         //Run City.ini
  DDScene->BackgroundBitmap = szDrive + "\\Graphics\\Back.bmp";
  DD->Init();                                    //Initialize Direct Draw
  lpDDS_Screen = DDUtils::DDCreateSurface(1152, 864);

  //Load pictures into Bitmaps-------------------\\
  for (C = 1; C < TotPics; C++) {
    if ((C > 0) & (C < 10)) Pic = "P00" + IntToStr(C);
    else if ((C > 9) & (C < 100)) Pic = "P0" + IntToStr(C);
    else if ((C > 99) & (C < 1000)) Pic = "P" + IntToStr(C);
    lpDDS[C] = DDLoadBitmap(0, Pic, true, RGB(128, 0, 128));
    ISize = DDGetImageSize(NULL, Pic.c_str());
    Req[C].dx = ISize.X;
    Req[C].dy = ISize.Y;
  }

  Pic = szDrive + "\\Graphics\\Blank.bmp";
  lpDDS_Blank = DDLoadBitmap(0, Pic, true, RGB(128, 0, 128));

  for (C = 1; C < 5; C++) {
    Pic = szDrive + "\\Graphics\\Curpos" + IntToStr(C) + ".bmp";
    lpDDS_Cursor[C] = DDLoadBitmap(0, Pic, true, RGB(128, 0, 128));
  }
  Server("ECHO; " + IntToStr(TotPics + 4) + " Pictures loaded;", true, true);
  Server("ECHO; " + DD->GetVersion() + ";", true, true);
  Server("ECHO; Image Positioning engine: Version 2.2;", true, true);
  Server("ECHO; Graphics engine: Version 2.3d;", true, true);

  //Setup Console--------------------------------\\
  Console_P->Left = 0;
  Console_P->Top = Screen->Height - 175;
  Console_P->Width = Screen->Width;

  //Set up panels--------------------------------\\
  New_GB->Left = (Screen->Width - New_GB->Width) / 2;
  New_GB->Top = (Screen->Height - New_GB->Height) / 2.5;
  Start_GB->Left = (Screen->Width - Start_GB->Width) / 2;
  Start_GB->Top = (Screen->Height - Start_GB->Height) / 2.5;
  Budget_P->Left = (Screen->Width - Budget_P->Width) / 2;
  Budget_P->Top = (Screen->Height - Budget_P->Height) / 2.5;
  Server("EXEC; Default.ini;", true, true);      //Run Defualt.ini

  //Setup Map Grid-------------------------------\\
  for (YC = 0; YC < MapHeight * 2; YC++) {
    for (XC = 0; XC < MapWidth; XC++) {
      TilePos[YC][XC] = S2_IntToIPoint(-1, -1);  //Assume blank
    }
  }

  XC = MapWidth / 2;                             //Set XC to 80
  for (C = 0; C < MapWidth; C++) {               //Starting position
    for (YC = C; YC < C + MapHeight; YC++) {     //Tile Start
      TilePos[YC + 2][XC] = S2_IntToIPoint(MapX, MapY);
      MapX++;                                    //Increase X
      if (Swap == true) {                        //Move X Down?
        Swap = false;
        XC++;                                    //Move X Down
      }
      else Swap = !Swap;
    }
    MapX = 0;                                    //Reset MapX
    MapY++;                                      //Increase MapY
    if (Swap == true) XC -= MapWidth / 2;        //Move back 40 or 41
    else XC -= (MapWidth / 2) + 1;
    Swap = !Swap;
  }
  //---------------------------------------------\\
  Reset_Variables();
  Server("Code; 20; 1; 0; 3; 0; 0; 0; Railway;", false, true);

} //FormCreate
//---------------------------------------------------------------------------
//Form-----------------------------------------------------------------------
void __fastcall TMainForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  int C;
  if (Panel1->Visible == false) return;          //Check if game is running
  for (C = 0; C < Max_Draw_Y; C++) {             //Get Y Position of cursor
    if ((Y > YTP[C]) & (Y <= YTP[C + 1])) {
      CurPos.Tile.Y = C;
      break;
    }
  }
  for (C = 0; C < Max_Draw_X; C++) {             //Get X Position of cursor
    if ((X > XTP[C]) & (X <= XTP[C + 1])) {
      CurPos.Tile.X = C;
      break;
    }
  }
  CurPos.Tile.Y++;                               //Get nearer pointer
  CurPos.Tile.X += Horz_SB->Position;            //Add distance of scrollbar
  CurPos.Tile.Y += Vert_SB->Position;            //ditto
  if (TilePos[CurPos.Tile.Y][CurPos.Tile.X].X == -1)
   CurPos.Visible = false;
  else CurPos.Visible = true;

  CurPos.Coord.X = XTP[CurPos.Tile.X - Horz_SB->Position];
  CurPos.Coord.Y = YTP[CurPos.Tile.Y - Vert_SB->Position];
  if (S2_Check4_OddNo(CurPos.Tile.Y) == true)    //Shift X to tile position
   CurPos.Coord.X -= 30;

  CurPos.Tile = TilePos[CurPos.Tile.Y][CurPos.Tile.X];
  if ((City.Tool_Code == 1000) | (City.Tool_Code == 1100))
   CurPos.Coord.X -= 31 * (Req[10].Size - 1);
  else
   CurPos.Coord.X -= 31 * (Req[City.Tool_Code].Size - 1);
} //FormMouseMove
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Panel1->Visible == false) return;          //Check if game is Running
  if (CurPos.Visible == false) return;           //Cursor off Map

  if (City.Tool_Cost > City.Money) {             //Check money
    Server("SOUND; PLAY; Money.wav;", true, true);
    return;
  }
  if (Shift.Contains(ssShift) == true) {         //Check if Shift is pressed
    if (CurPos.StartXY.X == -1) {                //Start X not set
      CurPos.StartXY.X = CurPos.Tile.X;
      CurPos.StartXY.Y = CurPos.Tile.Y;
    }
    else {                                       //Start X set
      CurPos.DropXY.X = CurPos.Tile.X;
      CurPos.DropXY.Y = CurPos.Tile.Y;
      MouseDrag(CurPos.StartXY, CurPos.DropXY);
      CurPos.StartXY.X = -1;                     //Reset StartXY
    }
    return;
  }
  //Query----------------------------------------\\
  if (City.Tool_Code == 1000)                    //Query
   QuerySetup(CurPos.Tile.X, CurPos.Tile.Y);
  //Centre---------------------------------------\\
  else if (City.Tool_Code == 1100) {             //Centre
    Horz_SB->Position = CurPos.Tile.X;
    Vert_SB->Position = CurPos.Tile.Y;
  }
  //Subway---------------------------------------\\
  else if (City.Tool_Code == 22) {               //Subway
    City.Tool_Cost = 400 + (100 * Search_Code5(CurPos.Tile.X, CurPos.Tile.Y, 22, 80));
    if (City.Tool_Cost > City.Money) {           //Check money
      Server("SOUND; PLAY; Money.wav;", true, true);
      return;
    }
    if (Set_Code(CurPos.Tile.X, CurPos.Tile.Y, City.Tool_Code,
     Req[City.Tool_Code].Size, 0) == false) {
      Server("SOUND; PLAY; Terrain.wav;", true, true);
      return;
    }
    City.Money -= City.Tool_Cost;                //Subtract cost away from funds
    return;
  }
  //Bulldoze-------------------------------------\\
  else if (City.Tool_Code == 9) {                //Bulldoze
    IPoint New_Tile = CurPos.Tile;
    int X, Y, Old_Code;
    if (Check4_ClearTerrain(CurPos.Tile.X, CurPos.Tile.Y, 0) == true)
     Reset_Tile(CurPos.Tile.X, CurPos.Tile.Y, 9);
    else {
      //Move cursor to top left of image---------\\
      if (MapSquare[CurPos.Tile.Y][CurPos.Tile.X].Code == 250) {
        New_Tile.X = MapSquare[CurPos.Tile.Y][CurPos.Tile.X].OrigX;
        New_Tile.Y = MapSquare[CurPos.Tile.Y][CurPos.Tile.X].OrigY;
      }
      //Reduce Population------------------------\\
      if (Check_Code(New_Tile.X, New_Tile.Y, F_RESIDENTIAL_CHECK) == true) {
        City.R_Pop -= Req[MapSquare[New_Tile.Y][New_Tile.X].Code].Num;
      }
      if (Check_Code(New_Tile.X, New_Tile.Y, F_COMMERCIAL_CHECK) == true) {
        City.C_Pop -= Req[MapSquare[New_Tile.Y][New_Tile.X].Code].Num;
      }
      if (Check_Code(New_Tile.X, New_Tile.Y, F_INDUSTRIAL_CHECK) == true) {
        City.I_Pop -= Req[MapSquare[New_Tile.Y][New_Tile.X].Code].Num;
      }
      //Single Tile------------------------------\\
      if (Req[MapSquare[New_Tile.Y][New_Tile.X].Code].Size == 1) {
        Reset_Tile(New_Tile.X, New_Tile.Y, 10);
      }
      //Multiple Tiles---------------------------\\
      else if (Req[MapSquare[New_Tile.Y][New_Tile.X].Code].Size > 1) {
        Old_Code = Req[MapSquare[New_Tile.Y][New_Tile.X].Code].Size;
        for (Y = New_Tile.Y; Y < New_Tile.Y + Old_Code; Y++) {
          for (X = New_Tile.X; X < New_Tile.X + Old_Code; X++) {
            Reset_Tile(X, Y, 10);
          }
        }
      }
    }
  }
  //Tree-----------------------------------------\\
  else if (City.Tool_Code == 11) {
    if (Check_Code(CurPos.Tile.X, CurPos.Tile.Y, 11) == true) {
      if (MapSquare[CurPos.Tile.Y][CurPos.Tile.X].Int1 < 11) {
        MapSquare[CurPos.Tile.Y][CurPos.Tile.X].Int1++;
      }
    }
    else {
      if (Set_Code(CurPos.Tile.X, CurPos.Tile.Y, 11, 1, 0) == true)
       MapSquare[CurPos.Tile.Y][CurPos.Tile.X].Int1 = 1;
      else Server("SOUND; PLAY; Terrain.wav;", true, true);
    }
  }
  //Power----------------------------------------\\
  else if (City.Tool_Code == 36) {
    if (Check4_ClearTerrain(CurPos.Tile.X, CurPos.Tile.Y, 0) == true)
     MapSquare[CurPos.Tile.Y][CurPos.Tile.X].Int1 = 36;
    if ((Check_Code(CurPos.Tile.X, CurPos.Tile.Y, 17) == true) |
        (Check_Code(CurPos.Tile.X, CurPos.Tile.Y, 20) == true))
     MapSquare[CurPos.Tile.Y][CurPos.Tile.X].Int1 = 36;
  }
  //---------------------------------------------\\
  else {
    if (Set_Code(CurPos.Tile.X, CurPos.Tile.Y, City.Tool_Code,
     Req[City.Tool_Code].Size, 0) == false) {
      Server("SOUND; PLAY; Terrain.wav;", true, true);
    }
    else {
      if ((City.Tool_Code >= 13) & (City.Tool_Code <= 16)) Check_Years();
    }
  }
  if (City.Tool_Code == 21) {
    Add_Object(CurPos.Tile.X, CurPos.Tile.Y, 20);
  }
  else if (City.Tool_Code == 110) {
    Add_Object(CurPos.Tile.X, CurPos.Tile.Y, 12);
  }

  City.Money -= City.Tool_Cost;                  //Subtract cost away from funds
} //FormMouseDown
//---------------------------------------------------------------------------
void __fastcall TMainForm::MouseDrag(IPoint Start, IPoint Drop)
{
  IPoint Temp;                                   //Tempory IPoint
  int XSize = 0, YSize = 0;                      //X, Y Size
  int XC, YC;                                    //X, Y Counter
  int Counter;                                   //Counter

  if (Start.Y > Drop.Y) {                        //Turn North into South
    Temp.Y = Start.Y;                            //Swap Start Y to Drop Y
    Start.Y = Drop.Y;
    Drop.Y = Temp.Y;
  }
  if (Start.X > Drop.X) {                        //Turn West into East
    Temp.X = Start.X;                            //Swap Start X to Drop X
    Start.X = Drop.X;
    Drop.X = Temp.X;
  }
  for (Counter = Start.Y; Counter < Drop.Y + 1; Counter += Req[City.Tool_Code].Size)
   YSize++;                                      //Calculate Y Size
  for (Counter = Start.X; Counter < Drop.X + 1; Counter += Req[City.Tool_Code].Size)
   XSize++;                                      //Calculate X Size
  Counter = 0;                                   //Zero Counter (For money)
  for (YC = 0; YC < YSize; YC += Req[City.Tool_Code].Size) {
    for (XC = 0; XC < XSize; XC += Req[City.Tool_Code].Size) {
      Counter += City.Tool_Cost;                 //Add cost
      if (Check4_ClearTerrain(Start.X + XC, Start.Y + YC, 0) == false) {
        Server("SOUND; PLAY; Terrain.wav;", true, true);
        return;
      }
      if (City.Money < Counter) {                //Check funds
        Server("SOUND; PLAY; Money.wav;", true, true);
        return;
      }
    }
  }
  for (YC = 0; YC < YSize; YC += Req[City.Tool_Code].Size) {
    for (XC = 0; XC < XSize; XC += Req[City.Tool_Code].Size) {
      Set_Code(Start.X + XC, Start.Y + YC, City.Tool_Code, Req[City.Tool_Code].Size, 0);
    }
  }
  City.Money -= Counter;                         //Subtract cost
} //MouseDrag
//---------------------------------------------------------------------------
void __fastcall TMainForm::GameKeyBown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if (Key == VK_UP) {                            //Move Up?
    if (Vert_SB->Position > Vert_SB->Min) Vert_SB->Position -= Vert_SB->SmallChange;
  }
  else if (Key == VK_DOWN) {                     //Move Down?
    if (Vert_SB->Position < Vert_SB->Max) Vert_SB->Position += Vert_SB->SmallChange;
  }
  else if (Key == VK_LEFT) {                     //Move Left?
    if (Horz_SB->Position > Vert_SB->Min) Horz_SB->Position -= Horz_SB->SmallChange;
  }
  else if (Key == VK_RIGHT) {                    //Move Right?
    if (Horz_SB->Position < Vert_SB->Max) Horz_SB->Position += Horz_SB->SmallChange;
  }
  Key = NULL;
}
//Main Menu------------------------------------------------------------------
void __fastcall TMainForm::F_NewCityClick(TObject *Sender)
{
  Start_GB->Visible = false;
  Refresh();
  Server("NEWCITY;", false, true);
} //F_NewCityClick
//---------------------------------------------------------------------------
#pragma warn -sig
void __fastcall TMainForm::F_LoadCityClick(TObject *Sender)
{
  char F_Line[164];
  AnsiString F_Hex;
  int XP, YP, CP;
  Clock->Enabled = false;

  if (OpenDialog->Execute()) {
    Reset_Variables();
    ifstream F_Name(OpenDialog->FileName.c_str());
    if (!F_Name)
     Server("ERROR; Can't Open " + OpenDialog->FileName + ";", false, true);
    Clock->Enabled = false;
//Load City Name---------------------------------\\
    F_Name.getline(F_Line, sizeof(F_Line));
    SplitComm(F_Line);
    City.Name = Comms[1];
//Load DateM-------------------------------------\\
    F_Name.getline(F_Line, sizeof(F_Line));
    SplitComm(F_Line);
    F_Hex = "0x" + Comms[1];
    City.DateM = StrToInt(F_Hex);
//Load DateY-------------------------------------\\
    F_Hex = "0x" + Comms[2];
    City.DateY = StrToInt(F_Hex);
//Load Money-------------------------------------\\
    F_Hex = "0x" + Comms[3];
    City.Money = StrToInt(F_Hex);
//Load Status------------------------------------\\
    F_Hex = "0x" + Comms[4];
    City.Status = StrToInt(F_Hex);
//R Pop------------------------------------------\\
    F_Name.getline(F_Line, sizeof(F_Line));
    SplitComm(F_Line);
    F_Hex = "0x" + Comms[1];
    City.R_Pop = StrToInt(F_Hex);
//C Pop------------------------------------------\\
    F_Hex = "0x" + Comms[2];
    City.C_Pop = StrToInt(F_Hex);
//I Pop------------------------------------------\\
    F_Hex = "0x" + Comms[2];
    City.I_Pop = StrToInt(F_Hex);
//PT_Tax-----------------------------------------\\
    F_Name.getline(F_Line, sizeof(F_Line));
    SplitComm(F_Line);
    F_Hex = "0x" + Comms[1];
    City.Budget.PT_Tax = StrToInt(F_Hex);
//PS_Tax-----------------------------------------\\
    F_Hex = "0x" + Comms[2];
    City.Budget.PS_Tax = StrToInt(F_Hex);
//FS_Tax-----------------------------------------\\
    F_Hex = "0x" + Comms[3];
    City.Budget.FS_Tax = StrToInt(F_Hex);
//Ho_Tax-----------------------------------------\\
    F_Hex = "0x" + Comms[4];
    City.Budget.Ho_Tax = StrToInt(F_Hex);
//Ed_Tax-----------------------------------------\\
    F_Hex = "0x" + Comms[5];
    City.Budget.Ed_Tax = StrToInt(F_Hex);
//Tr_Tax-----------------------------------------\\
    F_Hex = "0x" + Comms[6];
    City.Budget.Tr_Tax = StrToInt(F_Hex);
//Map--------------------------------------------\\
    for(YP = 0; YP < 80; YP++) {
      CP = 0;
      F_Name.getline(F_Line, sizeof(F_Line));
      SplitComm(F_Line);
      for(XP = 0; XP < 80; XP++) {
        F_Hex = "0x";
        F_Hex += Comms[1].c_str()[CP];
        F_Hex += Comms[1].c_str()[CP + 1];
        CP += 2;
        MapSquare[YP][XP].Code = StrToInt(F_Hex);
      }
    }
//OrigX------------------------------------------\\
    for(YP = 0; YP < 80; YP++) {
      CP = 0;
      F_Name.getline(F_Line, sizeof(F_Line));
      SplitComm(F_Line);
      for(XP = 0; XP < 80; XP++) {
        F_Hex = "0x";
        F_Hex += Comms[1].c_str()[CP];
        F_Hex += Comms[1].c_str()[CP + 1];
        CP += 2;
        MapSquare[YP][XP].OrigX = StrToInt(F_Hex);
      }
    }
//OrigY------------------------------------------\\
    for(YP = 0; YP < 80; YP++) {
      CP = 0;
      F_Name.getline(F_Line, sizeof(F_Line));
      SplitComm(F_Line);
      for(XP = 0; XP < 80; XP++) {
        F_Hex = "0x";
        F_Hex += Comms[1].c_str()[CP];
        F_Hex += Comms[1].c_str()[CP + 1];
        CP += 2;
        MapSquare[YP][XP].OrigY = StrToInt(F_Hex);
      }
    }
//Int1-------------------------------------------\\
    for(YP = 0; YP < 80; YP++) {
      CP = 0;
      F_Name.getline(F_Line, sizeof(F_Line));
      SplitComm(F_Line);
      for(XP = 0; XP < 80; XP++) {
        F_Hex = "0x";
        F_Hex += Comms[1].c_str()[CP];
        F_Hex += Comms[1].c_str()[CP + 1];
        CP += 2;
        MapSquare[YP][XP].Int1 = StrToInt(F_Hex);
      }
    }
//Int2-------------------------------------------\\
    for(YP = 0; YP < 80; YP++) {
      CP = 0;
      F_Name.getline(F_Line, sizeof(F_Line));
      SplitComm(F_Line);
      for(XP = 0; XP < 80; XP++) {
        F_Hex = "0x";
        F_Hex += Comms[1].c_str()[CP];
        F_Hex += Comms[1].c_str()[CP + 1];
        CP += 2;
        MapSquare[YP][XP].Int2 = StrToInt(F_Hex);
      }
    }
    F_Name.close();                              //Close file
    Setup_Screen();                              //Arrange Screen
    Budget_False_Setup();                        //Do Budget - but no money
    Do_All();
    Generate_Objects(false);                     //Generate Objects
    Check_Years();
    Clock->Enabled = true;
  }
}
#pragma warn -sig
//---------------------------------------------------------------------------
void __fastcall TMainForm::F_SaveClick(TObject *Sender)
{
  AnsiString F_Hex;
  int XP, YP;
  if (SaveDialog->Execute()) {
    ofstream F_Name(SaveDialog->FileName.c_str());
    if (!F_Name)
     Server("ERROR; Can't save to " + SaveDialog->FileName + ";", false, true);
    else {
      Clock->Enabled = false;
//Name-------------------------------------------\\
      F_Name << City.Name.c_str() << ";#" << endl;
//DateM------------------------------------------\\
      F_Hex = IntToHex(City.DateM, 1);
      F_Name << F_Hex.c_str() << "; ";
//DateY------------------------------------------\\
      F_Hex = IntToHex(City.DateY, 3);
      F_Name << F_Hex.c_str() << "; ";
//Money------------------------------------------\\
      F_Hex = IntToHex(City.Money, 1);
      F_Name << F_Hex.c_str() << "; ";
//Status-----------------------------------------\\
      F_Hex = IntToHex(City.Status, 1);
      F_Name << F_Hex.c_str() << ";#" << endl;
//R Pop------------------------------------------\\
      F_Hex = IntToHex(City.R_Pop, 1);
      F_Name << F_Hex.c_str() << "; ";
//C Pop------------------------------------------\\
      F_Hex = IntToHex(City.C_Pop, 1);
      F_Name << F_Hex.c_str() << "; ";
//I Pop------------------------------------------\\
      F_Hex = IntToHex(City.I_Pop, 1);
      F_Name << F_Hex.c_str() << ";#" << endl;
//PT_Tax-----------------------------------------\\
      F_Hex = IntToHex(City.Budget.PT_Tax, 1);
      F_Name << F_Hex.c_str() << "; ";
//PS_Tax-----------------------------------------\\
      F_Hex = IntToHex(City.Budget.PS_Tax, 1);
      F_Name << F_Hex.c_str() << "; ";
//FS_Tax-----------------------------------------\\
      F_Hex = IntToHex(City.Budget.FS_Tax, 1);
      F_Name << F_Hex.c_str() << "; ";
//Ho_Tax-----------------------------------------\\
      F_Hex = IntToHex(City.Budget.Ho_Tax, 1);
      F_Name << F_Hex.c_str() << "; ";
//Ed_Tax-----------------------------------------\\
      F_Hex = IntToHex(City.Budget.Ed_Tax, 1);
      F_Name << F_Hex.c_str() << "; ";
//Tr_Tax-----------------------------------------\\
      F_Hex = IntToHex(City.Budget.Tr_Tax, 1);
      F_Name << F_Hex.c_str() << ";#" << endl;
//Map--------------------------------------------\\
      for(YP = 0; YP < 80; YP++) {
        F_Hex = "";
        for(XP = 0; XP < 80; XP++) {
          F_Hex += IntToHex(MapSquare[YP][XP].Code, 2);
        }
        F_Name << F_Hex.c_str() << ";#" << endl;
      }
//OrigX------------------------------------------\\
      for(YP = 0; YP < 80; YP++) {
        F_Hex = "";
        for(XP = 0; XP < 80; XP++) {
          F_Hex += IntToHex(MapSquare[YP][XP].OrigX, 2);
        }
        F_Name << F_Hex.c_str() << ";#" << endl;
      }
//OrigY------------------------------------------\\
      for(YP = 0; YP < 80; YP++) {
        F_Hex = "";
        for(XP = 0; XP < 80; XP++) {
          F_Hex += IntToHex(MapSquare[YP][XP].OrigY, 2);
        }
        F_Name << F_Hex.c_str() << ";#" << endl;
      }
//Int1-------------------------------------------\\
      for(YP = 0; YP < 80; YP++) {
        F_Hex = "";
        for(XP = 0; XP < 80; XP++) {
          if (MapSquare[YP][XP].Int1 < 130)
           F_Hex += IntToHex(MapSquare[YP][XP].Int1, 2);
          else
           F_Hex += IntToHex(0, 2);
        }
        F_Name << F_Hex.c_str() << ";#" << endl;
      }
//Int2-------------------------------------------\\
      for(YP = 0; YP < 80; YP++) {
        F_Hex = "";
        for(XP = 0; XP < 80; XP++) {
          if (MapSquare[YP][XP].Int2 < 0) MapSquare[YP][XP].Int2 = 0;
          if (MapSquare[YP][XP].Int2 > 130) F_Hex += IntToHex(0, 2);
          else F_Hex += IntToHex(MapSquare[YP][XP].Int2, 2);
        }
        F_Name << F_Hex.c_str() << ";#" << endl;
      }
//Report back------------------------------------\\
      Server("INFO; Game Saved as " + SaveDialog->FileName + ";", false, true);
    }
    F_Name.close();                              //Close file
    Clock->Enabled = true;
  }
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::F_ExitClick(TObject *Sender)
{Server("QUIT;", false, true);}
//---------------------------------------------------------------------------
//Clock Speeds---------------------------------------------------------------
void __fastcall TMainForm::S_PauseClick(TObject *Sender)
{
  if (S_Slow->Checked) S_Slow->Checked = false;
  if (S_Medium->Checked) S_Medium->Checked = false;
  if (S_Fast->Checked) S_Fast->Checked = false;
  S_Pause->Checked = true;
  Server("SPEED; 0;", true, true);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_SlowClick(TObject *Sender)
{
  if (S_Pause->Checked) S_Pause->Checked = false;
  if (S_Medium->Checked) S_Medium->Checked = false;
  if (S_Fast->Checked) S_Fast->Checked = false;
  S_Slow->Checked = true;
  Server("SPEED; " + IntToStr(Speed_Slow) + ";", true, true);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_MediumClick(TObject *Sender)
{
  if (S_Pause->Checked) S_Pause->Checked = false;
  if (S_Slow->Checked) S_Slow->Checked = false;
  if (S_Fast->Checked) S_Fast->Checked = false;
  S_Medium->Checked = true;
  Server("SPEED; " + IntToStr(Speed_Med) + ";", true, true);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_FastClick(TObject *Sender)
{
  if (S_Pause->Checked) S_Pause->Checked = false;
  if (S_Slow->Checked) S_Slow->Checked = false;
  if (S_Medium->Checked) S_Medium->Checked = false;
  S_Fast->Checked = true;
  Server("SPEED; " + IntToStr(Speed_Fast) + ";", true, true);
}
//End of Clock Speeds--------------------------------------------------------
void __fastcall TMainForm::O_A_BudgetClick(TObject *Sender)
{
  O_A_Budget->Checked = !O_A_Budget->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::O_CDAudioClick(TObject *Sender)
{
  if (O_CDAudio->Enabled == true) {
    if (O_CDAudio->Checked == true) Server("CD; STOP;", false, true);
    O_CDAudio->Checked = !O_CDAudio->Checked;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::O_SoundFXClick(TObject *Sender)
{
  if (O_SoundFX->Enabled == true) {
    O_SoundFX->Checked = !O_SoundFX->Checked;
    WaveSound->SoundOn = O_SoundFX->Checked;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::W_ConsoleClick(TObject *Sender)
{
  W_Console->Checked = !W_Console->Checked;
  Console_P->Visible = W_Console->Checked;
  C_Input_E->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::W_ToolsClick(TObject *Sender)
{
  W_Tools->Checked = !W_Tools->Checked;          //Toolbar
  Tools_GB->Visible = W_Tools->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::H_AboutClick(TObject *Sender)
{
  AboutBox->ShowModal();
}
//End of Main menu-----------------------------------------------------------
//Start of game--------------------------------------------------------------
void __fastcall TMainForm::S_Ok_BClick(TObject *Sender)
{
  Start_GB->Visible = false;
  if (S_New_RB->Checked == true) Server("NEWCITY;", false, true);
  else if (S_Load_RB->Checked == true) F_LoadCityClick(Sender);
  else if (S_Sound_RB->Checked == true) {
    Start_GB->Visible = true;
    SoundBox->ShowModal();
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_Exit_BClick(TObject *Sender)
{Server("QUIT;", false, true);}
//Name City------------------------------------------------------------------
void __fastcall TMainForm::N_Ok_BClick(TObject *Sender)
{
  Reset_Variables();
  for (int Y = 0; Y < 80; Y++){
    for (int X = 0; X < 80; X++){
      MapSquare[Y][X].Code = 9;
      MapSquare[Y][X].OrigX = 0;
      MapSquare[Y][X].OrigY = 0;
      MapSquare[Y][X].Int1 = 0;
      MapSquare[Y][X].Int2 = 0;
    }
  }
  Generate_Map();
  City.Name = N_Name_E->Text;
  if (N_Easy_RB->Checked == true) City.Money = 20000;
  else if (N_Hard_RB->Checked == true) City.Money = 10000;
  City.Status = 1;
  City.R_Pop = 0;
  City.C_Pop = 0;
  City.I_Pop = 0;
  City.DateM = 1;
  City.DateY = 1950;
  City.Speed = Speed_Med;
  Setup_Screen();                                //Arrange Screen
  Budget_False_Setup();                          //Do Budget - but no money
  Do_All();
  Check_Years();                                 //Buildings availiable
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::B_Ok_BClick(TObject *Sender)
{
  City.Budget.PT_Tax = UpDown1->Position;
  City.Budget.PS_Tax = UpDown2->Position;
  City.Budget.FS_Tax = UpDown3->Position;
  City.Budget.Ho_Tax = UpDown4->Position;
  City.Budget.Ed_Tax = UpDown5->Position;
  City.Budget.Tr_Tax = UpDown6->Position;
  Budget_P->Visible = false;
  Clock->Enabled = true;
}
//---------------------------------------------------------------------------
//Tool Bar Icons-------------------------------------------------------------
void __fastcall TMainForm::Bulldoze_SBClick(TObject *Sender)
{Server("SET_TOOL; 1; 9; Bulldoze; 10; BULLDOZE.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Landscape_SBClick(TObject *Sender)
{Landscape_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Gifts_SBClick(TObject *Sender)
{Gifts_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Gifts_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Road_SBClick(TObject *Sender)
{Road_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Road_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Rail_SBClick(TObject *Sender)
{Rail_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Rail_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Ports_SBClick(TObject *Sender)
{Ports_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Power_SBClick(TObject *Sender)
{Power_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Power_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Pipes_SBClick(TObject *Sender)
{Server("SET_TOOL; 8; 45; Water Pump; 100; WPUMP.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Sewage_SBClick(TObject *Sender)
{Sewage_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Residential_SBClick(TObject *Sender)
{Residential_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Commercial_SBClick(TObject *Sender)
{Commercial_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Industrial_SBClick(TObject *Sender)
{Industrial_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Religion_SBClick(TObject *Sender)
{Religion_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Recreation_SBClick(TObject *Sender)
{Recreation_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Recreation_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Services_SBClick(TObject *Sender)
{Services_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Services_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Education_SBClick(TObject *Sender)
{Education_PM->Popup(PopUp_Position.X, PopUp_Position.Y - Education_PM->Tag);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Query_SBClick(TObject *Sender)
{Server("SET_TOOL; 17; 1000; Query; 0; QUERY.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Emergancy_SBClick(TObject *Sender)
{Emergancy_PM->Popup(PopUp_Position.X, PopUp_Position.Y);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RCCWSBClick(TObject *Sender)
{
  //
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RCWiSBClick(TObject *Sender)
{
  //
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Centre_SBClick(TObject *Sender)
{Server("SET_TOOL; 19; 1100; Centre; 0; CENTRE.WAV;", false, true);}
//Pop up menus---------------------------------------------------------------
//Landscape------------------------------------------------------------------
void __fastcall TMainForm::L_TreesClick(TObject *Sender)
{Server("SET_TOOL; 2; 11; Trees; 5; TREES.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::L_LakeClick(TObject *Sender)
{Server("SET_TOOL; 2; 12; Lake; 100; LAKE.WAV;", false, true);}
//Gifts----------------------------------------------------------------------
void __fastcall TMainForm::G_CityHallClick(TObject *Sender)
{Server("SET_TOOL; 3; 13; City Hall; 0; HALL.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::G_FountainClick(TObject *Sender)
{Server("SET_TOOL; 3; 14; Fountain; 0; FOUNT.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::G_StatueClick(TObject *Sender)
{Server("SET_TOOL; 3; 15; Statue; 0; STATUE.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::G_YourHouseClick(TObject *Sender)
{Server("SET_TOOL; 3; 16; Your House; 0; HOUSE;", false, true);}
//Road-----------------------------------------------------------------------
void __fastcall TMainForm::R_RoadClick(TObject *Sender)
{Server("SET_TOOL; 4; 17; Road; 20; ROADS.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_MotorWayClick(TObject *Sender)
{Server("SET_TOOL; 4; 18; Motor Way; 200; MOTORWAY.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_BusStationClick(TObject *Sender)
{Server("SET_TOOL; 4; 19; Bus Station; 300; BUSS.WAV;", false, true);}
//Rail-----------------------------------------------------------------------
void __fastcall TMainForm::R_RailClick(TObject *Sender)
{Server("SET_TOOL; 5; 20; Railway; 40; RAIL.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_StationClick(TObject *Sender)
{Server("SET_TOOL; 5; 21; Station; 500; RSTATION.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_SubStationClick(TObject *Sender)
{Server("SET_TOOL; 5; 22; Sub-Station; 400; SSTATION.WAV;", false, true);}
//Ports----------------------------------------------------------------------
void __fastcall TMainForm::P_AirClick(TObject *Sender)
{Server("SET_TOOL; 6; 23; Air Port; 200; AIRPORT.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_SeaClick(TObject *Sender)
{Server("SET_TOOL; 6; 30; Sea Port; 150; SEAPORT.WAV;", false, true);}
//Power----------------------------------------------------------------------
void __fastcall TMainForm::P_PowerLineClick(TObject *Sender)
{Server("SET_TOOL; 7; 36; Power Line; 10; POWER.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_CoalClick(TObject *Sender)
{Server("SET_TOOL; 7; 37; Coal Power Plant; 4000; COAL.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_OilClick(TObject *Sender)
{Server("SET_TOOL; 7; 38; Oil Power Plant; 5500; OIL.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_GasClick(TObject *Sender)
{Server("SET_TOOL; 7; 39; Gas Power Plant; 3000; GAS.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_NuclearClick(TObject *Sender)
{Server("SET_TOOL; 7; 40; Nuclear Power Plant; 12000; NUCLEAR.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_WindClick(TObject *Sender)
{Server("SET_TOOL; 7; 41; Wind Turbine; 100; WIND.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_SolarClick(TObject *Sender)
{Server("SET_TOOL; 7; 42; Solar Power Plant; 1600; SOLAR.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::P_MicroWaveClick(TObject *Sender)
{Server("SET_TOOL; 7; 43; MicroWave Power Plant; 26500; MICRO.WAV;", false, true);}
//Pipes----------------------------------------------------------------------
void __fastcall TMainForm::S_TreatmentClick(TObject *Sender)
{Server("SET_TOOL; 9; 46; Treatment; 400; TREAT.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_UVTreatmentClick(TObject *Sender)
{Server("SET_TOOL; 9; 47; U.V Treatment; 1000; UVTREAT.WAV;", false, true);}
//Residentual----------------------------------------------------------------
void __fastcall TMainForm::R_LDensityClick(TObject *Sender)
{Server("SET_TOOL; 10; 48; R Low Density; 10; RESI.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_HDensityClick(TObject *Sender)
{Server("SET_TOOL; 10; 49; R High Density; 20; RESI.WAV;", false, true);}
//Commercial-----------------------------------------------------------------
void __fastcall TMainForm::C_LDensityClick(TObject *Sender)
{Server("SET_TOOL; 11; 65; C Low Density; 10; COMMER.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::C_HDensityClick(TObject *Sender)
{Server("SET_TOOL; 11; 66; C High Density; 20; COMMER.WAV;", false, true);}
//Industrial-----------------------------------------------------------------
void __fastcall TMainForm::I_LDensityClick(TObject *Sender)
{Server("SET_TOOL; 12; 82; I Low Density; 10; INDUS.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::I_HDensityClick(TObject *Sender)
{Server("SET_TOOL; 12; 83; I High Density; 20; INDUS.WAV;", false, true);}
//Religon--------------------------------------------------------------------
void __fastcall TMainForm::R_ChurchClick(TObject *Sender)
{Server("SET_TOOL; 13; 99; Church; 500; CHURCH.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_CathedralClick(TObject *Sender)
{Server("SET_TOOL; 13; 100; Cathedral; 1000; CATH.WAV;", false, true);}
//Recreation-----------------------------------------------------------------
void __fastcall TMainForm::R_SmallParkClick(TObject *Sender)
{Server("SET_TOOL; 14; 108; Small Park; 30; SPARK.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_LargeParkClick(TObject *Sender)
{Server("SET_TOOL; 14; 109; Large Park; 200; LPARK.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_MarinaClick(TObject *Sender)
{Server("SET_TOOL; 14; 110; Marina; 1000; MARINA.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::R_StadiumClick(TObject *Sender)
{Server("SET_TOOL; 14; 111; Stadium; 5000; STADIUM.WAV;", false, true);}
//City Services--------------------------------------------------------------
void __fastcall TMainForm::S_PoliceClick(TObject *Sender)
{Server("SET_TOOL; 15; 101; Police Station; 1000; PSTATION.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_FireClick(TObject *Sender)
{Server("SET_TOOL; 15; 102; Fire Station; 1000; FSTATION.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::S_HospitalClick(TObject *Sender)
{Server("SET_TOOL; 15; 103; Hospital; 1000; HOSPIT.WAV;", false, true);}
//Education------------------------------------------------------------------
void __fastcall TMainForm::E_SchoolClick(TObject *Sender)
{Server("SET_TOOL; 16; 104; School; 400; SCHOOL.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::E_CollegeClick(TObject *Sender)
{Server("SET_TOOL; 16; 105; College; 1000; COLLEGE.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::E_LibraryClick(TObject *Sender)
{Server("SET_TOOL; 16; 106; Library; 500; OK.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::E_MuseumClick(TObject *Sender)
{Server("SET_TOOL; 16; 107; Museum; 800; MUSEUM.WAV;", false, true);}
//Emergancy------------------------------------------------------------------
void __fastcall TMainForm::E_PoliceClick(TObject *Sender)
{Server("SET_TOOL; 18; 112; Police; 0; OK.WAV;", false, true);}
//---------------------------------------------------------------------------
void __fastcall TMainForm::E_FireClick(TObject *Sender)
{Server("SET_TOOL; 18; 113; Firefighters; 0; OK.WAV;", false, true);}
//Clock----------------------------------------------------------------------
void __fastcall TMainForm::ClockTimer(TObject *Sender)
{
  AnsiString Info[6];                            //Strings for Information
  int XP, YP;                                    //Map X and Y
  Clock->Tag += Clock->Interval;                 //Increase Month
  if (E_Limit > 0) E_Time += Clock->Interval;    //Increase Echo Time
  if (E_Time >= E_Limit) {                       //Avoid Overflow
    E_Limit = 0;                                 //Set Limit to 0
    E_Time = 0;                                  //Set time to 0
  }
  Sprite_No++;                                   //Increase Sprite
  if (Sprite_No >= 5) Sprite_No = 1;             //Avoid Overflow

  //Date-----------------------------------------\\
  if (Clock->Tag >= City.Speed) {                //Check if month needs changing
    Clock->Tag = 0;                              //Reset Clock
    if (City.DateM < 13) City.DateM ++;          //Check if year needs changing
    if (City.DateM == 13) {
      City.DateM = 1;                            //Reset Month
      City.DateY++;                              //Add 1 to year
      Check_Status();                            //Check Status
      Budget_Setup();                            //Budget
    }
    //Check Map Squares--------------------------\\
    Do_All();
    for (YP = 0; YP < 80; YP++) {                //Y Loop
      for (XP = 0; XP < 80; XP++) {              //X Loop
        if (MapSquare[YP][XP].Code < 4) {        //Construction
          if (MapSquare[YP][XP].Power == true) MapSquare[YP][XP].Int2--;
          if (MapSquare[YP][XP].Int2 <= 0) {
            MapSquare[YP][XP].Code = MapSquare[YP][XP].Int1;
            MapSquare[YP][XP].Int2 = 0;
          }
        }
        if ((Check_Direction(XP, YP, F_POWER_CHECK, 1) == true) |
            (Check_Direction(XP, YP, F_POWER_CHECK, 2) == true) |
            (Check_Direction(XP, YP, F_POWER_CHECK, 3) == true) |
            (Check_Direction(XP, YP, F_POWER_CHECK, 4) == true)) {
          if (MapSquare[YP][XP].Code == 23) Build_Airport(XP, YP);
          else if (MapSquare[YP][XP].Code == 30) Build_Seaport(XP, YP);
          else if (MapSquare[YP][XP].Code == 48) Build_LDensity(XP, YP, 48);
          else if (MapSquare[YP][XP].Code == 49) Build_HResidential(XP, YP);
          else if (MapSquare[YP][XP].Code == 65) Build_LDensity(XP, YP, 65);
          else if (MapSquare[YP][XP].Code == 66) Build_HCommercial(XP, YP);
          else if (MapSquare[YP][XP].Code == 82) Build_LDensity(XP, YP, 82);
          else if (MapSquare[YP][XP].Code == 83) Build_HIndustrial(XP, YP);
        }
      }
    }
  }
  if (E_Limit == 0) {
    //Set Info Strings---------------------------\\
    Info[1] = Months[City.DateM] + " " + City.DateY + "    ";
    Info[2] = "Funds: " + IntToStr(City.Money) + "        ";
    Info[3] = City.Tool_Name + "            ";
    Info[4] = "Cost: " + IntToStr(City.Tool_Cost) + "       ";
    Info[5] = "Status: " + S2_GetStatus(City.Status) + "     ";
    Info[6] = "Pop: " + IntToStr(City.R_Pop + City.C_Pop + City.I_Pop) + "     ";
    //Write on Screen----------------------------\\Memo "ECHO; str; PosX; PosY;"
    Server("ECHO; " + Info[1] + "; 273; 0;", false, true);
    Server("ECHO; " + Info[2] + "; 273; 1;", false, true);
    Server("ECHO; " + Info[3] + "; 273; 2;", false, true);
    Server("ECHO; " + Info[4] + "; 273; 3;", false, true);
    Server("ECHO; " + Info[5] + "; 273; 4;", false, true);
    Server("ECHO; " + Info[6] + "; 273; 5;", false, true);
  }
  //---------------------------------------------\\
  GraphicsDraw();                                //Draw Graphics
}
//Graphics-------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TMainForm::Add_Tile(int AX, int AY, IPoint IncXY, int DP)
{
  if ((AX < 0) | (AX >= Max_Draw_X)) return false;
  if ((AY < 0) | (AY >= Max_Draw_Y)) return false;
  if (DP > Max_Draw_X * Max_Draw_Y) return false;
  if (Tiles_Done[AY][AX] == false) {
    Draw_Square[DP].X = AX + IncXY.X;
    Draw_Square[DP].Y = AY + IncXY.Y;
    Tiles_Done[AY][AX] = true;
  }
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GraphicsDraw()
{
  int XP, YP, Code, Num = 0;                     //Set Variables
  int Cur_Size, YP2;
  IPoint IncXY;
  IPoint FTemp;
  IncXY.X = Horz_SB->Position;
  IncXY.Y = Vert_SB->Position;
  const RECT None = {0, 0, 0, 0};
  const RECT Blank = {0, 0, 59, 31};
  RECT Cursor_Area;
  RECT Draw_Area;

  Move_Objects();                                //Move Object
  for (YP = 0; YP < Max_Draw_Y; YP++) {
    for (XP = 0; XP < Max_Draw_X; XP++) {
      Tiles_Done[YP][XP] = false;                //Reset Tiles_Done
    }
  }
  for (YP = 0; YP < Max_Draw_X * Max_Draw_Y; YP++) {
    Draw_Square[YP].X = -2;                      //Reset Draw_Square
    Draw_Square[YP].Y = -2;
  }
  for (YP = 0; YP < Max_Draw_Y; YP++) {
    for (XP = 0; XP < Max_Draw_X; XP++) {
      FTemp = TilePos[YP + IncXY.Y][XP + IncXY.X];
      if (FTemp.X == -1) {                       //Get Blanks
        if (Add_Tile(XP, YP, IncXY, Num) == true) Num++;
      }
    }
  }
  for (YP = 0; YP < Max_Draw_Y; YP+=4) {
    for (Cur_Size = 0; Cur_Size < 5; Cur_Size++) {
      for (YP2 = YP; YP2 <= YP + 4; YP2++) {
        for (XP = 0; XP < Max_Draw_X; XP++) {
          FTemp = TilePos[YP2 + IncXY.Y][XP + IncXY.X];
          if (Check_Code(FTemp.X, FTemp.Y, F_RANGE_CHECK) == true) {
            if (Check_Code(FTemp.X, FTemp.Y, 250) == true) {
              if (Add_Tile(XP, YP2, IncXY, Num) == true) Num++;
            }
            else if (Req[MapSquare[FTemp.Y][FTemp.X].Code].Size == Cur_Size) {
              if (Add_Tile(XP, YP2, IncXY, Num) == true) Num++;
            }
          }
        }
      }
    }
  }
  //Temp-----------------------------------------\\
  /*ofstream F_Name("Pics.txt");
  AnsiString F_Int;
  if (!F_Name)
   Server("ERROR; Can't save to " + SaveDialog->FileName + ";", false);
  else {
    for (YP = 0; YP < Max_Draw_X * Max_Draw_Y; YP++) {
      F_Int = IntToStr(YP) + ", " + IntToStr(Draw_Square[YP].X) + ", " + IntToStr(Draw_Square[YP].Y);
      F_Name << F_Int.c_str() << endl;
    }
  }
  F_Name.close();*/
  //Temp-----------------------------------------\\
  //Clear the Screen-----------------------------\\
  for (YP = 0; YP < Max_Draw_Y; YP++) {
    for (XP = 0; XP < Max_Draw_X; XP++) {
      Draw_Tile(XP, YP, -1, Blank);
    }
  }
  //Draw the tiles-------------------------------\\
  for (Num = 0; Num < Max_Draw_X * Max_Draw_Y; Num++) {
    XP = Draw_Square[Num].X;
    YP = Draw_Square[Num].Y;
    //if ((XP == -2) | (YP == -2))
    // Server("ECHO; Problem with Graphics Engine at: " + IntToStr(Num) + ";", false, true);
    if ((XP != -2) | (YP != -2)) {
      if (TilePos[YP][XP].X == -1) Draw_Tile(XP, YP, -1, Blank);
      else {
        if (Check_Code(TilePos[YP][XP].X, TilePos[YP][XP].Y, F_RANGE_CHECK) == true) {
          Code = MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Code;
          switch (Code) {
            case 11:                             //Tree
              Draw_Tile(XP, YP, 9, Blank);
              Draw_Tile(XP, YP, 11, None);
            break;
            case 12: Draw_Lake(XP, YP); break;     //Lake
            case 18: Draw_MWay(XP, YP); break;     //Motor Way
            case 17: Draw_RRR(XP, YP, 17, 17, 9); break;
            case 20: Draw_RRR(XP, YP, 20, 20, 9); break;
            case 29: Draw_RP(XP, YP, 0, 29); break;//Runway
            case 34: Draw_RP(XP, YP, 12, 34); break;
            default:
              if (Code != 250) Draw_Tile(XP, YP, Code, None);
            break;
          }
          if (Code != 250) {
            if (((Req[Code].P == true) |
                 (MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Int1 == 36)) &
             (MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Power == false)) {
              Draw_Tile(XP, YP, 118, None);
            }
            if ((Req[Code].W == true) &
             (MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Water == false)) {
              Draw_Tile(XP, YP, 119, None);
            }
            if ((Req[Code].S == true) &
             (MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Sewage == false)) {
              Draw_Tile(XP, YP, 120, None);
            }
            if (MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Int2 > 130) {
              Code = MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Int2 - 130;
              Draw_Tile(XP, YP, Objects[Code].P_Code + Objects[Code].Dir - 1, None);
            }
            if (MapSquare[TilePos[YP][XP].Y][TilePos[YP][XP].X].Int1 == 36) {
              Draw_RRR(XP, YP, 36, F_POWER_LINE, 0);//Draw Power Line
            }
          }
        }
      }
    }
  }
  //Draw the cursor------------------------------\\
  if (CurPos.Visible == true) {
    if ((City.Tool_Code == 1000) | (City.Tool_Code == 1100)) Code = 1;
    else Code = Req[City.Tool_Code].Size;
    Cursor_Area.left = 0;
    Cursor_Area.top = 0;
    Cursor_Area.right = (59 * Code) - (1 - Code);
    Cursor_Area.bottom = (31 * Code) + (1 - Code);
    CurPos.Coord.X += 156;
    CurPos.Coord.Y += 192;
    DDBlitFast(lpDDS_Screen, lpDDS_Cursor[Code], CurPos.Coord, Cursor_Area, Rect(0, 40, 1152, 864));
    CurPos.Coord.X -= 156;
    CurPos.Coord.Y -= 192;
  }
  Draw_Area = Rect(166, 212, 787, 541);
  DDScene->DDSurface->BltFast(0, 20, lpDDS_Screen, &Draw_Area, DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
  DD->Flip();                                    //Flip the surface
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Draw_RRR(int XP, int YP, int Pic, int S_Code, int U_Code)
{
  int Draw_Pic;                                  //Picture to Draw
  int X = TilePos[YP][XP].X;                     //Tile X
  int Y = TilePos[YP][XP].Y;                     //Tile Y
  IPoint Scr;                                    //Screen Position
  Scr.X = XTP[XP - Horz_SB->Position];           //Get Screen Position X
  Scr.Y = YTP[YP - Vert_SB->Position];           //Get Screen Position Y
  if (S2_Check4_OddNo(YP) == true) Scr.X -= 30;
  Scr.X += 156;
  Scr.Y += 192;
  RECT R = Rect(0, 0, 59, 31);                   //Image Area
  //---------------------------------------------\\
  if (U_Code) Draw_Tile(XP, YP, U_Code, R);
  if (Pic == 36) {                               //Power over Road / Rail
    if ((Check_Code(X, Y, 17) == true) |         //Road
        (Check_Code(X, Y, 20) == true)) {        //Rail
      if ((Check_Direction(X, Y, F_POWER_LINE, 1) == true) |
          (Check_Direction(X, Y, F_POWER_LINE, 3) == true))
       Draw_Pic = 160;
      if ((Check_Direction(X, Y, F_POWER_LINE, 2) == true) |
          (Check_Direction(X, Y, F_POWER_LINE, 4) == true))
       Draw_Pic = 161;
      Draw_Tile(XP, YP, Draw_Pic, Rect(0, 0, 0, 0));
      return;
    }
  }
  //N-E------------------------------------------\\
  if ((Check_Direction(X, Y, S_Code, 1) == true) &
      (Check_Direction(X, Y, S_Code, 3) == false) &
      (Check_Direction(X, Y, S_Code, 2) == true) &
      (Check_Direction(X, Y, S_Code, 4) == false)) Draw_Pic = 3;
  //S-E------------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == false) &
      (Check_Direction(X, Y, S_Code, 3) == true)  &
      (Check_Direction(X, Y, S_Code, 2) == true)  &
      (Check_Direction(X, Y, S_Code, 4) == false)) Draw_Pic = 4;
  //S-W------------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == false) &
      (Check_Direction(X, Y, S_Code, 3) == true) &
      (Check_Direction(X, Y, S_Code, 2) == false) &
      (Check_Direction(X, Y, S_Code, 4) == true)) Draw_Pic = 5;
  //N-W------------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == true) &
      (Check_Direction(X, Y, S_Code, 3) == false) &
      (Check_Direction(X, Y, S_Code, 2) == false) &
      (Check_Direction(X, Y, S_Code, 4) == true)) Draw_Pic = 6;
  //N-S-E----------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == true) &
      (Check_Direction(X, Y, S_Code, 3) == true) &
      (Check_Direction(X, Y, S_Code, 2) == true) &
      (Check_Direction(X, Y, S_Code, 4) == false)) Draw_Pic = 7;
  //S-E-W----------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == false) &
      (Check_Direction(X, Y, S_Code, 3) == true) &
      (Check_Direction(X, Y, S_Code, 2) == true) &
      (Check_Direction(X, Y, S_Code, 4) == true)) Draw_Pic = 8;
  //N-S-W----------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == true) &
      (Check_Direction(X, Y, S_Code, 3) == true) &
      (Check_Direction(X, Y, S_Code, 2) == false) &
      (Check_Direction(X, Y, S_Code, 4) == true)) Draw_Pic = 9;
  //N-E-W----------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == true) &
      (Check_Direction(X, Y, S_Code, 3) == false) &
      (Check_Direction(X, Y, S_Code, 2) == true) &
      (Check_Direction(X, Y, S_Code, 4) == true)) Draw_Pic = 10;
  //N-S------------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 2) == false) &
      (Check_Direction(X, Y, S_Code, 4) == false) &
     ((Check_Direction(X, Y, S_Code, 1) == true)  |
      (Check_Direction(X, Y, S_Code, 3) == true))) Draw_Pic = 1;
  //E-W------------------------------------------\\
  else if ((Check_Direction(X, Y, S_Code, 1) == false) &
      (Check_Direction(X, Y, S_Code, 3) == false) &
     ((Check_Direction(X, Y, S_Code, 2) == true) |
      (Check_Direction(X, Y, S_Code, 4) == true))) Draw_Pic = 2;
  //N-E-S-W--------------------------------------\\
  else Draw_Pic = 11;
  if (S_Code == 17) Draw_Pic += 124;
  else if (S_Code == 20) Draw_Pic += 135;
  else if (S_Code == F_POWER_LINE) Draw_Pic += 148;
  Draw_Tile(XP, YP, Draw_Pic, Rect(0, 0, 0, 0));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Draw_MWay(int XP, int YP)
{
  Draw_Tile(XP + 1, YP + 4, 18, Rect(0, 0, 118, 60));
  if ((Check_Code(TilePos[YP][XP].X + 2, TilePos[YP][XP].Y, 18) == true) |
      (Check_Code(TilePos[YP][XP].X - 2, TilePos[YP][XP].Y, 18) == true)) {
    Draw_Tile(XP + 1, YP + 4, 18, Rect(119, 61, 237, 121));
  }
  else
   Draw_Tile(XP + 1, YP + 4, 18, Rect(0, 61, 118, 121));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Draw_Lake(int XP, int YP)
{
  int X = TilePos[YP][XP].X;                     //Tile X
  int Y = TilePos[YP][XP].Y;                     //Tile Y
  RECT R = Rect(0, 0, 59, 31);
  Draw_Tile(XP, YP, 12, R);
  if (Check_Direction(X, Y, 12, 1) == true) Draw_Tile(XP, YP, 162, R);
  if (Check_Direction(X, Y, 12, 2) == true) Draw_Tile(XP, YP, 163, R);
  if (Check_Direction(X, Y, 12, 3) == true) Draw_Tile(XP, YP, 164, R);
  if (Check_Direction(X, Y, 12, 4) == true) Draw_Tile(XP, YP, 165, R);
  if (Check_Direction(X, Y, 34, 1) == true) Draw_Tile(XP, YP, 162, R);
  if (Check_Direction(X, Y, 34, 2) == true) Draw_Tile(XP, YP, 163, R);
  if (Check_Direction(X, Y, 34, 3) == true) Draw_Tile(XP, YP, 164, R);
  if (Check_Direction(X, Y, 34, 4) == true) Draw_Tile(XP, YP, 165, R);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Draw_RP(int XP, int YP, int U_Code, int P_Code)
{
  int X = TilePos[YP][XP].X;                     //Tile X
  int Y = TilePos[YP][XP].Y;                     //Tile Y
  RECT R = Rect(0, 0, 59, 31);
  if (U_Code == 12) Draw_Lake(XP, YP);
  if (MapSquare[Y][X].Int1 == 6)
   Draw_Tile(XP, YP, P_Code, R);
  else if (MapSquare[Y][X].Int1 == 5) {
    if (P_Code == 34) Draw_Tile(XP, YP, 167, R);
    if (P_Code == 29) Draw_Tile(XP, YP, 166, R);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Draw_Tile(int XC, int YC, int Code, RECT Grid)
{
  IPoint Scr;

  Scr.X = XTP[XC - Horz_SB->Position];           //Get Screen Position X
  Scr.Y = YTP[YC - Vert_SB->Position];           //Get Screen Position Y
  if (S2_Check4_OddNo(YC) == true) Scr.X -= 30;
  Scr.X += 156;
  Scr.Y += 192;
  //Blank Image----------------------------------\\
  if (Code == -1) {
    DDBlitFast(lpDDS_Screen, lpDDS_Blank, Scr, Grid, Rect(0, 40, 1152, 864));
    return;
  }
  //If Size not set then use default size--------\\
  if (Grid.right == 0) Grid.right = Req[Code].dx;
  if (Grid.bottom == 0) Grid.bottom = Req[Code].dy;
  //Sprite---------------------------------------\\
  if (Req[Code].Sprite > 0) {
    if (Sprite_No == 1) Code = Code;
    else Code = Req[Code].Sprite + (Sprite_No - 2);
    //else ShowMessage(Code);
  }
  //Move image in line to grid?------------------\\
  if (Req[Code].Size == 1) {
    if (Req[Code].dy > 31) Scr.Y -= (Req[Code].dy - 31);
  }
  else if (Req[Code].Size == 2) {
    if (Req[Code].dy > 61) Scr.Y -= Req[Code].dy - 61;
    Scr.X -= 30;
  }
  else if (Req[Code].Size == 3) {
    if (Req[Code].dy > 91) Scr.Y -= Req[Code].dy - 91;
    Scr.X -= 60;
  }
  else if (Req[Code].Size == 4) {
    if (Req[Code].dy > 121) Scr.Y -= Req[Code].dy - 121;
    Scr.X -= 90;
  }
  if (Code == 11) {
    int Num;
    IPoint Pos[10];
    Pos[1] = S2_IntToIPoint(27 + Scr.X, 3 + Scr.Y);
    Pos[2] = S2_IntToIPoint(37 + Scr.X, 5 + Scr.Y);
    Pos[3] = S2_IntToIPoint(20 + Scr.X, 7 + Scr.Y);
    Pos[4] = S2_IntToIPoint(30 + Scr.X, 7 + Scr.Y);
    Pos[5] = S2_IntToIPoint(40 + Scr.X, 10 + Scr.Y);
    Pos[6] = S2_IntToIPoint(10 + Scr.X, 10 + Scr.Y);
    Pos[7] = S2_IntToIPoint(28 + Scr.X, 11 + Scr.Y);
    Pos[8] = S2_IntToIPoint(10 + Scr.X, 12 + Scr.Y);
    Pos[9] = S2_IntToIPoint(16 + Scr.X, 15 + Scr.Y);
    Pos[10] = S2_IntToIPoint(28 + Scr.X, 17 + Scr.Y);

    for (Num = 1; Num <= MapSquare[TilePos[YC][XC].Y][TilePos[YC][XC].X].Int1; Num++)
     DDBlitFast(lpDDS_Screen, lpDDS[11], Pos[Num], Grid, Rect(0, 40, 1152, 864));
    return;
  }
  DDBlitFast(lpDDS_Screen, lpDDS[Code], Scr, Grid, Rect(0, 40, 1152, 864));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::C_Input_EKeyPress(TObject *Sender, char &Key)
{
  if (Key == VK_RETURN) {
    Server(C_Input_E->Text, true, false);
    Key = NULL;
  }
} //C_Input_EKeyPress
//---------------------------------------------------------------------------
void __fastcall TMainForm::C_Input_EKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  AnsiString A_Str;
  if (Key == VK_UP) {
    A_Str = S2_GetCommand(1);
    if (A_Str == "ERROR; Server Error;") Server(A_Str, false, true);
    else C_Input_E->Text = A_Str;
    Key = NULL;
  }
  else if (Key == VK_DOWN) {
    A_Str = S2_GetCommand(2);
    if (A_Str == "ERROR; Server Error;") Server(A_Str, false, true);
    else C_Input_E->Text = A_Str;
    Key = NULL;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Server(AnsiString Comm1, bool C_Show, bool szCity)
{
  AnsiString C_Message;
  Comm1.Trim();                                  //Remove any spaces b/f
  if (SplitComm(Comm1) == -1) return;            //Error splitting the command
  Comms[1] = Comms[1].UpperCase();               //Convert to upper case
  if (szCity == false) S2_AddCommand(Comm1);     //Add command to list
  //---------------------------------------------\\
  if (Comms[1] == "ERROR") {
    if (Clock->Enabled == true) Clock->Enabled = false;
    if (DD->ADirectDraw != NULL) DD->ADirectDraw->FlipToGDISurface();
    Application->MessageBox(Comms[2].c_str(), "Error", MB_OK | MB_ICONERROR);
    Application->Terminate();
  }
  //---------------------------------------------\\
  else if (Comms[1] == "QUIT") {
    Clock->Enabled = false;
    Application->Terminate();
  }
  //---------------------------------------------\\
  else if (Comms[1] == "CD") {
    C_Show = true;
    if (O_CDAudio->Enabled == false) C_Message = "CD Audio is disabled";
    else if (O_CDAudio->Checked == false) C_Message = "CD Audio is turned off";
    else {
      if (Comms[2].UpperCase() == "PLAY") {
        if (Comms[3].Length() > 0)
         CDPlay(Comms[3]);
        else
         CDPlay("");
        if (CDGetMode() == cdPlaying) C_Message = "CD Playing";
      }
      else if (Comms[2].UpperCase() == "INIT") {
        if (Exec_CDComm("INIT") == "CD Audio initialised") {
          O_CDAudio->Checked = true;
          O_CDAudio->Enabled = true;
          C_Message = "CD Audio initialised";
        }
        else {
          O_CDAudio->Checked = false;
          O_CDAudio->Enabled = false;
          C_Message = "CD Audio Not initialised";
        }
      }
      else C_Message = Exec_CDComm(Comms[2].UpperCase());
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "CHECK_COMMERCIAL") {
    if (Check_Zone_Pop(F_COMMERCIAL_CHECK) == true) C_Message = "C Yes";
    else C_Message = "C No";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "CHECK_INDUSTRIAL") {
    if (Check_Zone_Pop(F_INDUSTRIAL_CHECK) == true) C_Message = "I Yes";
    else C_Message = "I No";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "CHECK_RESIDENTIAL") {
    if (Check_Zone_Pop(F_RESIDENTIAL_CHECK) == true) C_Message = "R Yes";
    else C_Message = "R No";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "CODE") {
    Req[Comms[2].ToInt()].Size = Comms[3].ToInt();
    Req[Comms[2].ToInt()].Num = Comms[4].ToInt();
    Req[Comms[2].ToInt()].Flag = Comms[5].ToInt();
    Req[Comms[2].ToInt()].P = S2_IntToBool(Comms[6].ToInt());
    Req[Comms[2].ToInt()].S = S2_IntToBool(Comms[7].ToInt());
    Req[Comms[2].ToInt()].W = S2_IntToBool(Comms[8].ToInt());
    Req[Comms[2].ToInt()].Name = Comms[9];
  }
  //Echo-----------------------------------------\\
  else if (Comms[1] == "ECHO") {
    if (Comms[3].Length() > 0) {
      Comms[2] += "               ";
      DDScene->WriteXY(Comms[3].ToInt(), TTP[Comms[4].ToInt()], Comms[2],
       RGB(50, 40, 200), RGB(128, 128, 128));
    }
    C_Message = Comms[2];
  }
//---------------------------------------------\\
  else if (Comms[1] == "EXEC") {
    char F_Line[55];                           //Characters to read
    ifstream File(Comms[2].c_str());           //Open file
    if (!File) Server("WARNING; Can't exec " + Comms[2] + ";", true, true);
    else {
      C_Message = "Execing " + Comms[2];
      while (!File.eof()) {                      //Loop until End of File
        File.getline(F_Line, 55);                //Read Line
        Server(F_Line, false, true);
      }
      File.close();                              //Close "City.ini"
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "GET_CURSOR") {
    Screen->Cursors[Comms[2].ToInt()] = LoadCursor((void *)HInstance, Comms[3].c_str());
  }
  //---------------------------------------------\\
  else if (Comms[1] == "GET_LOCATION") {
    unsigned int UC;
    char szDirectory[MAX_PATH];                  //Directory Size
    szDrive = "";
    GetModuleFileName(NULL, szDirectory, MAX_PATH);
    for (UC = 0; UC < StrLen(szDirectory) - 16; UC++)
     szDrive += szDirectory[UC];
    C_Message = "Location: " + szDrive;
  }
  //---------------------------------------------\\
  else if (Comms[1] == "INFO") {
    Application->MessageBox(Comms[2].c_str(), "City Builder", MB_OK | MB_ICONINFORMATION);
  }
  //---------------------------------------------\\
  else if (Comms[1] == "NAME") {
    if (Comms[2].Length() < 1) C_Message = "Name is " + City.Name;
    else {
      C_Message = City.Name + " changed to " + Comms[2];
      City.Name = Comms[2];
      Panel1->Caption = City.Name;
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "NEWCITY") {        
    New_GB->Visible = true;
    C_Message = "Starting new game...";
  }
  //---------------------------------------------\\
  else if (Comms[1] == "PLAY_VIDEOS") {
    if (Comms[2].Length() > 0) {
      Play_Videos = S2_IntToBool(Comms[2].ToInt());
    }
    else {
      if (Play_Videos == true) C_Message = "PLAY_VIDEOS: True";
      else C_Message = "PLAY_VIDEOS: False";
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "R_INFO") {
    if (Comms[2].ToInt() < TotPics) {
      AnsiString Re[8];
      Re[1] = "Size: " + IntToStr(Req[Comms[2].ToInt()].Size);
      Re[2] = " Num: " + IntToStr(Req[Comms[2].ToInt()].Num);
      if (Req[Comms[2].ToInt()].P == true) Re[3] = " P: Yes";
      else Re[3] = " P: No";
      if (Req[Comms[2].ToInt()].S == true) Re[4] = " S: Yes";
      else Re[4] = " S: No";
      if (Req[Comms[2].ToInt()].W == true) Re[5] = " W: Yes";
      else Re[5] = " W: No";
      Re[6] = " dx: " + IntToStr(Req[Comms[2].ToInt()].dx);
      Re[7] = " dy: " + IntToStr(Req[Comms[2].ToInt()].dy);
      Re[8] = Req[Comms[2].ToInt()].Name;
      C_Message = Re[1] + Re[2] + Re[3] + Re[4] + Re[5] + Re[6] + Re[7] + Re[8];
    }
    else C_Message = "Incorrect Number: " + Comms[2];
  }
  //---------------------------------------------\\
  else if (Comms[1] == "RANDOM") {
    C_Message = "Num: " + IntToStr(GetNum(Comms[2].ToInt()));
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SET_POPUP_POSITION") {
    PopUp_Position.X = Comms[2].ToInt();
    PopUp_Position.Y = Comms[3].ToInt();
    C_Message = "Position set to " + Comms[2] + ", " + Comms[3];
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SET_TOOL") {
    if (C_Show == true)
     C_Message = "SET_TOOL can't be accessed from the console";
    else {
      if (Comms[5].ToInt() > City.Money)         //Not enough money
       Server("SOUND; PLAY; money.wav;", true, true);
      else {                                     //enough money
        Screen->Cursor = TCursor(Comms[2].ToInt());
        City.Tool_Code = Comms[3].ToInt();
        City.Tool_Name = Comms[4];
        City.Tool_Cost = Comms[5].ToInt();
        Server("SOUND; PLAY; " + Comms[6] + ";", true, true);
      }
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SOUND") {
    C_Show = true;
    if (Comms[2].UpperCase() == "INIT") {
      WaveSound->Init(0, 0, 0);
      O_SoundFX->Checked = WaveSound->SoundOn;
      O_SoundFX->Enabled = WaveSound->Active;;
      C_Message = WaveSound->CommReturn;
      //Server("ECHO; " + WaveSound->GetWaveFormat() + ";", true, true);
      //WaveSound->GetWaveFormat();
    }
    else if (Comms[2].UpperCase() == "PLAY") {
      AnsiString AS = szDrive + "\\Sound\\" + Comms[3];
      WaveSound->Play(AS, false, SND_ASYNC | SND_FILENAME | SND_NODEFAULT);
        //DDSound->Open(AS, 2);
        //DDSound->Play(2, false);
      C_Message = WaveSound->CommReturn;
    }
    else {
      if (Comms[3] == "")
       C_Message = WaveSound->Exec_Comm(Comms[2].UpperCase());
      else
       C_Message = WaveSound->Exec_Comm(Comms[2].UpperCase(), (DWORD) Comms[3].ToInt());
    }
    if (C_Message.c_str()[0] == '~') {
        C_Show = false;
        Server(C_Message.SubString(2, C_Message.Length() - 1), true, true);
    }
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SPEED") {
    if (Comms[2] == "0") Clock->Enabled = false;
    else Clock->Enabled = true;
    if (Comms[2].Length() > 0) City.Speed = Comms[2].ToInt();
    C_Message = "Speed = " + IntToStr(City.Speed);
  }
  //---------------------------------------------\\
  else if (Comms[1] == "SPRITE") {
    Req[Comms[2].ToInt()].Sprite = Comms[3].ToInt();
  }
  //---------------------------------------------\\
  else if (Comms[1] == "WARNING") {
    int MBRet;
    MBRet = Application->MessageBox(Comms[2].c_str(), "Warning", MB_ABORTRETRYIGNORE | MB_ICONWARNING);
    if (MBRet == IDABORT) Application->Terminate();
    else if (MBRet == IDRETRY) Server(S2_GetPreviousCommand(), C_Show, true);
    C_Message = "A WARNING occured";
  }
  //---------------------------------------------\\
  else C_Message = "Command " + Comm1 + " not accepted!";
  //---------------------------------------------\\
  if (C_Show == true) {
    if (C_Memo->Lines->Count >= 30) C_Memo->Lines->Delete(29);
    C_Memo->Lines->Insert(0, C_Message);
  }
} //Server
//---------------------------------------------------------------------------
bool __fastcall TMainForm::Add_Object(int X, int Y, int O_Num)
{
  int Search_Num, P_Num, O_Max_Speed, AI;
  IPoint Position;
  for (Search_Num = 1; Search_Num < 50; Search_Num++)
   if (Objects[Search_Num].Moving == false) break;//Get Empty Object
  if (Search_Num >= 50) return false;            //No Space

  if (O_Num == 20) {
    P_Num = 114;
    O_Max_Speed = 3;
    AI = 1;
  }
  else if (O_Num == 12) {
    P_Num = 198;
    O_Max_Speed = 6;
    AI = 2;
  }

  Position = Search_Code(X, Y, O_Num, 3);        //Find F_Code
  if (Position.X > -1) {                         //Found
    Objects[Search_Num].Dir = GetNum(4);         //Set Direction
    Objects[Search_Num].Cur_Speed = 0;           //Not Moved
    Objects[Search_Num].Max_Speed = O_Max_Speed; //Set Max Speed
    Objects[Search_Num].AI_Code = AI;            //Set AI_Code
    Objects[Search_Num].P_Code = P_Num;          //Set P_Code
    Objects[Search_Num].Pos = Position;          //Set Position
    Objects[Search_Num].Moving = true;           //Moving
    Server("ECHO; Object generated at: " + IntToStr(Position.X) + ", " + IntToStr(Position.Y) + ";", true, true);
  }
  else {
    Server("ECHO; Object not generated;", true, true);
    return false;                                //Not Found
  }
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Add_Pollution(int SX, int SY, int Rad, int Add)
{
  int XP, YP;
  for (YP = SY - (Rad); YP < SY + Rad + 1; YP++) {
    for (XP = SX - (Rad); XP < SX + Rad + 1; XP++) {
      if (Check_Code(XP, YP, F_RANGE_CHECK) == true) {
         if (Add > 0) MapSquare[YP][XP].Pollution += Add;
         else MapSquare[YP][XP].Pollution -= abs(Add);
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Add_S4_Tiles(int Add)
{
  int TX, TY;
  for (TY = 1; TY < 7; TY++) {
    for (TX = 1; TX < 7; TX++) {
      if (S4_Tiles[TY][TX].X > -1) {
        if (Add < 0) {
          if (MapSquare[S4_Tiles[TY][TX].Y][S4_Tiles[TY][TX].X].Traffic < abs(Add))
           MapSquare[S4_Tiles[TY][TX].Y][S4_Tiles[TY][TX].X].Traffic = 0;
          else
           MapSquare[S4_Tiles[TY][TX].Y][S4_Tiles[TY][TX].X].Traffic += Add;
        }
        else
         MapSquare[S4_Tiles[TY][TX].Y][S4_Tiles[TY][TX].X].Traffic += Add;
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Budget_Setup()
{
  int Start_M = (City.R_Pop + City.C_Pop + City.I_Pop) * (UpDown1->Position / 2);
  int Reduce[5];
  Reduce[1] = (Search_Code2(101) * 3) * UpDown2->Position;
  Reduce[2] = (Search_Code2(102) * 2.5) * UpDown3->Position;
  Reduce[3] = (Search_Code2(103) * 3) * UpDown4->Position;
  Reduce[4] = (Search_Code2(104) + Search_Code2(105) * 1.5) * UpDown5->Position;
  Reduce[5] = ((Search_Code2(17) * 0.7) + (Search_Code2(20) * 0.6)) * UpDown6->Position;
  B_City_Name->Caption = City.Name;
  B_Year->Caption = IntToStr(City.DateY) + " Budget";
  UpDown1->Position = City.Budget.PT_Tax;        //Property Tax
  UpDown2->Position = City.Budget.PS_Tax;        //Police
  UpDown3->Position = City.Budget.FS_Tax;        //Fire
  UpDown4->Position = City.Budget.Ho_Tax;        //Hospital
  UpDown5->Position = City.Budget.Ed_Tax;        //Eductaion
  UpDown6->Position = City.Budget.Tr_Tax;        //Transport
  B_PT_L->Caption = IntToStr(Start_M);
  B_PS_L->Caption = Reduce[1];
  B_FS_L->Caption = Reduce[2];
  B_Ho_L->Caption = Reduce[3];
  B_Ed_L->Caption = Reduce[4];
  B_Tr_L->Caption = Reduce[5];
  B_Gross_L->Tag = Reduce[1] + Reduce[2] + Reduce[3] + Reduce[4] + Reduce[5];
  B_Gross_L->Caption = IntToStr(B_Gross_L->Tag);
  B_Net_L->Tag = Start_M - B_Gross_L->Tag;
  B_Net_L->Caption = B_Net_L->Tag;
  Clock->Enabled = O_A_Budget->Checked;          //Stop clock?
  Budget_P->Visible = !O_A_Budget->Checked;      //Show Panel?
  City.Money += B_Net_L->Tag;                    //Add Money
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Budget_False_Setup()
{
//Stops stupid results---------------------------\\
  int Start_M = (City.R_Pop + City.C_Pop + City.I_Pop) * (UpDown1->Position / 2);
  int Reduce[5];
  Reduce[1] = (Search_Code2(101) * 3) * UpDown2->Position;
  Reduce[2] = (Search_Code2(102) * 2.5) * UpDown3->Position;
  Reduce[3] = (Search_Code2(103) * 3) * UpDown4->Position;
  Reduce[4] = (Search_Code2(104) + Search_Code2(105) * 1.5) * UpDown5->Position;
  Reduce[5] = ((Search_Code2(17) * 0.7) + (Search_Code2(20) * 0.6)) * UpDown6->Position;
  B_City_Name->Caption = City.Name;
  B_Year->Caption = IntToStr(City.DateY) + " Budget";
  UpDown1->Position = City.Budget.PT_Tax;        //Property Tax
  UpDown2->Position = City.Budget.PS_Tax;        //Police
  UpDown3->Position = City.Budget.FS_Tax;        //Fire
  UpDown4->Position = City.Budget.Ho_Tax;        //Hospital
  UpDown5->Position = City.Budget.Ed_Tax;        //Eductaion
  UpDown6->Position = City.Budget.Tr_Tax;        //Transport
  B_PT_L->Caption = IntToStr(Start_M);
  B_PS_L->Caption = Reduce[1];
  B_FS_L->Caption = Reduce[2];
  B_Ho_L->Caption = Reduce[3];
  B_Ed_L->Caption = Reduce[4];
  B_Tr_L->Caption = Reduce[5];
  B_Gross_L->Tag = Reduce[1] + Reduce[2] + Reduce[3] + Reduce[4] + Reduce[5];
  B_Gross_L->Caption = IntToStr(B_Gross_L->Tag);
  B_Net_L->Tag = Start_M - B_Gross_L->Tag;
  B_Net_L->Caption = B_Net_L->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Build_Airport(int X, int Y)
{
  //Runway---------------------------------------\\
  if (GetNum(3) == 2) {                          //1 in 3 chance of runway
    if (Set_Code(X, Y, 29, 5, 23) == true) {     //Build Runway East?
      return;
    }
    if (Set_Code(X, Y, 29, 6, 23) == true) {     //Build Runway South?
      return;
    }
  }
  //Car Park-------------------------------------\\
  if (Search_Code(X, Y, 17, 1).X > -1) {
    if (GetNum(3) == 2) {
      if (Set_Code(X, Y, 26, 2, 23) == true) return;
    }
  }
  //Control Tower--------------------------------\\
  if ((Search_Code2(29) / 5) > Search_Code2(27)) {
    Set_Code(X, Y, 27, 1, 23);                   //Build Control Tower?
    return;
  }
  //Boeing 757-----------------------------------\\
  if ((Search_Code2(29) / 5) > Search_Code2(25)) {
    Set_Code(X, Y, 25, 1, 23);                   //Build Boeing 757
    return;
  }
  //Hanger---------------------------------------\\
  if (Set_Code(X, Y, 28, 2, 23) == true) return; //Build Hanger?
  //Airport Building-----------------------------\\
  Set_Code(X, Y, 24, 1, 23);                     //Build Airport building
} //Build_Airport
//---------------------------------------------------------------------------
void __fastcall TMainForm::Build_HResidential(int X, int Y)
{
  int R_Size = 0;
  int New_Size;
  int Num = GetNum(5);

  if (Check_Zone_Pop(F_RESIDENTIAL_CHECK) == false) return;
  if (Search_Code(X, Y, 17, 3).X == -1) return;  //Need road
  if (City.Status <= 2) R_Size = 0;
  else if ((City.Status == 3) | (City.Status == 4)) R_Size = 4;
  else if (City.Status >= 5) R_Size = 9;
  if (Search_Code(X, Y, F_INDUSTRIAL_CHECK, 3).X > -1) R_Size -= 1;
  if (Search_Code(X, Y, 12, 8).X > -1) R_Size += 3;
  if (Search_Code(X, Y, 14, 6).X > -1) R_Size += 8;
  if (Search_Code(X, Y, 16, 6).X > -1) R_Size += 8;
  if (Search_Code(X, Y, 19, 8).X > -1) R_Size += 3;
  if (Search_Code(X, Y, 21, 10).X > -1) R_Size += 2;
  if (Search_Code(X, Y, 22, 8).X > -1) R_Size += 3;
  if (Search_Code(X, Y, 18, 4).X > -1) R_Size -= 4;
  if (Search_Code(X, Y, 103, 10).X > -1) R_Size += 1;
  if (Search_Code(X, Y, 104, 10).X > -1) R_Size += 1;
  if (Search_Code(X, Y, 105, 16).X > -1) R_Size += 1;
  if (Search_Code(X, Y, 106, 10).X > -1) R_Size += 2;
  if (Search_Code(X, Y, 107, 16).X > -1) R_Size += 2;
  if (Search_Code(X, Y, 108, 8).X > -1) R_Size += 3;
  if (Search_Code(X, Y, 109, 8).X > -1) R_Size += 5;
  if (Search_Code(X, Y, 110, 8).X > -1) R_Size += 7;
  if (Search_Code(X, Y, 111, 8).X > -1) R_Size += 9;
  if (MapSquare[Y][X].Pollution > 11) R_Size -= 3;
  Server("ECHO; R: " + IntToStr(R_Size) + ";", true, true);

  if (R_Size < 0) return;
  else if (R_Size < 6) New_Size = 1;             //Work out size to build
  else if ((R_Size >= 6) & (R_Size < 15)) New_Size = 2;
  else if (R_Size >= 15) New_Size = 3;
  while(1)                                       //Create building
  {
    if (Set_Code(X, Y, New_Size, New_Size, 49) == true) {
      City.R_Pop += Req[44 + (5 * New_Size) + Num].Num;
      MapSquare[Y][X].Int1 = 44 + (5 * New_Size + Num);
      MapSquare[Y][X].Int2 = Req[44 + (5 * New_Size + Num)].Num / 15;
      break;
    }
    else New_Size--;                             //Reduce size if lack of space
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Build_HCommercial(int X, int Y)
{
  int C_Size = 0;
  int New_Size;
  int Num = GetNum(5);

  if (Check_Zone_Pop(F_COMMERCIAL_CHECK) == false) return;
  if (Search_Code(X, Y, 17, 3).X == -1) return;  //Need road
  if (City.Status <= 2) C_Size = 0;
  else if ((City.Status >= 3) | (City.Status <= 5)) C_Size = 4;
  else if (City.Status >= 6) C_Size = 9;
  if (Search_Code(X, Y, 13, 10).X > -1) C_Size += 8;
  if (Search_Code(X, Y, 14, 10).X > -1) C_Size += 2;
  if (Search_Code(X, Y, 15, 10).X > -1) C_Size += 1;
  if (Search_Code(X, Y, 18, 10).X > -1) C_Size += 2;
  if (Search_Code(X, Y, 19, 8).X > -1) C_Size += 3;
  if (Search_Code(X, Y, 21, 12).X > -1) C_Size += 4;
  if (Search_Code(X, Y, 22, 8).X > -1) C_Size += 3;
  if (Search_Code(X, Y, F_AIRPORT_CHECK, 16).X > -1) C_Size += 4;
  if (Search_Code(X, Y, 101, 10).X > -1) C_Size += 2;
  if (Search_Code(X, Y, 102, 10).X > -1) C_Size += 2;
  if (Search_Code(X, Y, 108, 8).X > -1) C_Size += 2;
  if (Search_Code(X, Y, 109, 10).X > -1) C_Size += 4;
  if (Search_Code(X, Y, 110, 10).X > -1) C_Size += 6;
  Server("ECHO; C: " + IntToStr(C_Size) + ";", true, true);

  if (C_Size < 0) return;
  else if (C_Size < 6) New_Size = 1;             //Work out size to build
  else if ((C_Size >= 6) & (C_Size < 15)) New_Size = 2;
  else if (C_Size >= 15) New_Size = 3;
  while(1)                                       //Create building
  {
    if (Set_Code(X, Y, New_Size, New_Size, 66) == true) {
      City.C_Pop += Req[61 + (5 * New_Size) + Num].Num;
      MapSquare[Y][X].Int1 = 61 + (5 * New_Size + Num);
      MapSquare[Y][X].Int2 = Req[61 + (5 * New_Size + Num)].Num / 10;
      break;
    }
    else New_Size--;                             //Reduce size if lack of space
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Build_HIndustrial(int X, int Y)
{
  int I_Size = 0;
  int New_Size;
  int Num = GetNum(5);
  if (Check_Zone_Pop(F_INDUSTRIAL_CHECK) == false) return;
  if (Search_Code(X, Y, 17, 3).X == -1) return;  //Need road
  if (City.Status <= 2) I_Size = 0;
  else if ((City.Status == 3) | (City.Status == 4)) I_Size = 5;
  else if (City.Status >= 5) I_Size = 11;
  if (Search_Code2(105) > 0) I_Size += 6;
  if (Search_Code(X, Y, 18, 10).X > -1) I_Size += 4;
  if (Search_Code(X, Y, 19, 4).X > -1) I_Size += 5;
  if (Search_Code(X, Y, 20, 10).X > -1) I_Size += 4;
  if (Search_Code(X, Y, 21, 4).X > -1) I_Size += 5;
  Server("ECHO; I: " + IntToStr(I_Size) + ";", true, true);

  if (I_Size < 0) return;
  else if (I_Size < 6) New_Size = 1;             //Work out size to build
  else if ((I_Size >= 6) & (I_Size < 12)) New_Size = 2;
  else if (I_Size >= 12) New_Size = 3;
  while(1)                                       //Create building
  {
    if (Set_Code(X, Y, New_Size, New_Size, 83) == true) {
      City.I_Pop += Req[78 + (5 * New_Size) + Num].Num;
      MapSquare[Y][X].Int1 = 78 + (5 * New_Size + Num);
      MapSquare[Y][X].Int2 = Req[78 + (5 * New_Size + Num)].Num / 10;
      break;
    }
    else New_Size--;                             //Reduce size if lack of space
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Build_LDensity(int X, int Y, int O_Code)
{
  int Number;
  if (Check_Zone_Pop((((O_Code + 3) / 17) + 4079)) == false) return;
  if (Search_Code(X, Y, 17, 3).X > -1) {
    Number = GetNum(6);
    if (Number == 6) return;
    Number += O_Code + 1;
    Set_Code(X, Y, 1, Req[Number].Size, O_Code);
    MapSquare[Y][X].Int1 = Number;
    MapSquare[Y][X].Int2 = Req[Number].Num / 10;
    if (O_Code == 48) City.R_Pop += Req[Number].Num;
    else if (O_Code == 65) City.C_Pop += Req[Number].Num;
    else if (O_Code == 82) City.I_Pop += Req[Number].Num;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Build_Seaport(int X, int Y)
{
  //Pier-----------------------------------------\\
  if (Set_Code(X + 1, Y, 34, 5, 12) == true) {   //Build Pier East?
    Set_Code(X, Y, 33, 1, 30);                   //Build Crane
    return;
  }
  if (Set_Code(X, Y + 1, 34, 6, 12) == true) {   //Build Pier South?
    Set_Code(X, Y, 33, 1, 30);                   //Build Crane
    return;
  }
  if (Set_Code(X - 5, Y, 34, 5, 12) == true) {   //Build Pier West?
    Set_Code(X, Y, 33, 1, 30);                   //Build Crane
    return;
  }
  if (Set_Code(X, Y - 5, 34, 6, 12) == true) {   //Build Pier North?
    Set_Code(X, Y, 33, 1, 30);                   //Build Crane
    return;
  }
  //Loading Bay / Cargo Yard---------------------\\
  if (GetNum(2) == 2) {
    if (Set_Code(X, Y, 31, 2, 30) == true) return;//Build Cargo yard?
  }
  else
   if (Set_Code(X, Y, 32, 2, 30) == true) return;//Build Loading bay?
  //Warehouse------------------------------------\\
  Set_Code(X, Y, 35, 1, 30);                     //Build Warehouse
} //Build_Seaport
//---------------------------------------------------------------------------
inline bool TMainForm::Check4_ClearTerrain(int X, int Y, int Code)
{
  bool Ret = false;
  if (Code == 0) {                               //Check for clear
    if (Check_Code(X, Y, 9) == true) Ret = true;//terrain / Zones
    else if (Check_Code(X, Y, 10) == true) Ret = true;
    else if (Check_Code(X, Y, 11) == true) Ret = true;
    else if (Check_Code(X, Y, 23) == true) Ret = true;
    else if (Check_Code(X, Y, 30) == true) Ret = true;
    else if (Check_Code(X, Y, 48) == true) Ret = true;
    else if (Check_Code(X, Y, 49) == true) Ret = true;
    else if (Check_Code(X, Y, 65) == true) Ret = true;
    else if (Check_Code(X, Y, 66) == true) Ret = true;
    else if (Check_Code(X, Y, 82) == true) Ret = true;
    else if (Check_Code(X, Y, 83) == true) Ret = true;
    else Ret = false;
  }                                              //Check for specific code
  else Ret = Check_Code(X, Y, Code);
  return Ret;
}
//---------------------------------------------------------------------------
inline bool TMainForm::Check_Code(int X, int Y, int Code)
{
  int Temp;
  if ((X < 0) | (X > 80)) return false;          //X in range (0 - 80)
  if ((Y < 0) | (Y > 80)) return false;          //Y in range (0 - 80)
  if (Code == F_RANGE_CHECK) return true;        //Range Check
  if ((Code >= F_RESIDENTIAL_CHECK) & (Code <= F_BUILDING_CHECK))
   return Check_Zone(X, Y, Code);                //Zone Check
  if (Code == 250) {                             //Check for 250
    Temp = X;
    X = MapSquare[Y][Temp].OrigX;                //Swap X for Orig X
    Y = MapSquare[Y][Temp].OrigY;                //Swap Y for Orig Y
  }
  if (Code == F_POWER_CHECK) return MapSquare[Y][X].Power;
  if (Code == F_POWER_LINE) {
    if (Check_Code(X, Y, F_BUILDING_CHECK) == true) return true;
    else if (MapSquare[Y][X].Int1 == 36) return true;
    else return false;
  }
  if (MapSquare[Y][X].Code == Code) return true;
  else return false;
  return false;
} //Check_Code
//---------------------------------------------------------------------------
inline bool TMainForm::Check_Direction(const int X, const int Y, int Code, int Dir)
{
  bool Ret = false;                              //Assume False
  /*Directions 1: North (Y--) */
  /*           2: East  (X++) */
  /*           3: South (Y++) */
  /*           4: West  (X--) */
  if (Dir == 1) Ret = Check_Code(X, Y - 1, Code);
  else if (Dir == 2) Ret = Check_Code(X + 1, Y, Code);
  else if (Dir == 3) Ret = Check_Code(X, Y + 1, Code);
  else if (Dir == 4) Ret = Check_Code(X - 1, Y, Code);
  return Ret;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Check_Status()
{
  int Church = Search_Code2(99);
  int Cathedral = Search_Code2(100);
  int Tot_Pop = City.R_Pop + City.C_Pop + City.I_Pop;
  unsigned int Old_Status = City.Status;

  if ((Church == 0) & (Tot_Pop < 500)) City.Status = 1;
  else if ((Church > 0) & (Tot_Pop < 2000)) City.Status = 2;
  else if ((Church > 0) & (Tot_Pop < 10000)) City.Status = 3;
  else if ((Church > 0) & (Cathedral > 0) & (Tot_Pop < 40000)) City.Status = 4;
  else if ((Church > 0) & (Cathedral > 0) & (Tot_Pop < 90000)) City.Status = 5;
  else if ((Church > 0) & (Cathedral > 0) & (Tot_Pop > 200000)) City.Status = 6;
  if (City.Status > Old_Status)
   Server("INFO; Congratulations your " + S2_GetStatus(Old_Status) + " is now a " + S2_GetStatus(City.Status) + ";", true, true);
  Check_Years();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Check_Years()
{
  for (int i = 1; i <= 9; i++) City.Years[i] = false;
  if (City.DateY > 1955) City.Years[1] = true;
  if (City.DateY > 1985) City.Years[2] = true;
  if (City.DateY > 1990) City.Years[3] = true;
  if (City.DateY > 1995) City.Years[4] = true;
  if (City.DateY > 2015) City.Years[5] = true;
  if ((City.Status >= 2) & (Search_Code2(16) == 0)) City.Years[6] = true;
  if ((City.Status >= 3) & (Search_Code2(14) == 0)) City.Years[7] = true;
  if ((City.Status >= 4) & (Search_Code2(13) == 0)) City.Years[8] = true;
  if ((City.Status >= 5) & (Search_Code2(15) == 0)) City.Years[9] = true;
  P_Nuclear->Enabled = City.Years[1];
  P_Wind->Enabled = City.Years[2];
  P_Solar->Enabled = City.Years[3];
  S_UVTreatment->Enabled = City.Years[4];
  P_MicroWave->Enabled = City.Years[5];
  G_YourHouse->Enabled = City.Years[6];
  G_Fountain->Enabled = City.Years[7];
  G_CityHall->Enabled = City.Years[8];
  G_Statue->Enabled = City.Years[9];
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::Check_Zone(int X, int Y, const int Code)
{
  bool Check = false;
  if (Code == F_RESIDENTIAL_CHECK) {
    if ((MapSquare[Y][X].Code >= 48) &
        (MapSquare[Y][X].Code <= 64)) Check = true;
  }
  else if (Code == F_COMMERCIAL_CHECK) {
    if ((MapSquare[Y][X].Code >= 65) &
        (MapSquare[Y][X].Code <= 81)) Check = true;
  }
  else if (Code == F_INDUSTRIAL_CHECK) {
    if ((MapSquare[Y][X].Code >= 82) &
        (MapSquare[Y][X].Code <= 98)) Check = true;
  }
  else if (Code == F_AIRPORT_CHECK) {
    if ((MapSquare[Y][X].Code >= 23) &
        (MapSquare[Y][X].Code <= 29)) Check = true;
  }
  else if (Code == F_SEAPORT_CHECK) {
    if ((MapSquare[Y][X].Code >= 30) &
        (MapSquare[Y][X].Code <= 35)) Check = true;
  }
  else if (Code == F_BUILDING_CHECK) {
    Check = true;
    if (Check_Code(X, Y, 9) == true) Check = false;
    else if (Check_Code(X, Y, 10) == true) Check = false;
    else if (Check_Code(X, Y, 11) == true) Check = false;
    else if (Check_Code(X, Y, 12) == true) Check = false;
    else if (Check_Code(X, Y, 17) == true) Check = false;
    else if (Check_Code(X, Y, 18) == true) Check = false;
    else if (Check_Code(X, Y, 20) == true) Check = false;
    else if (Check_Code(X, Y, 30) == true) Check = false;
    else if (Check_Code(X, Y, 48) == true) Check = false;
    else if (Check_Code(X, Y, 49) == true) Check = false;
    else if (Check_Code(X, Y, 65) == true) Check = false;
    else if (Check_Code(X, Y, 66) == true) Check = false;
    else if (Check_Code(X, Y, 82) == true) Check = false;
    else if (Check_Code(X, Y, 83) == true) Check = false;
    else if (Check_Code(X, Y, 108) == true) Check = false;
    else if (Check_Code(X, Y, 109) == true) Check = false;
    if (MapSquare[Y][X].Int1 == 36) Check = true;
  }
  return Check;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::Check_Zone_Pop(const int Check)
{
  bool Build = false;
  if (City.Budget.PT_Tax > 30) {                 //PT Tax > 30%
    if (GetNum(5 + City.Budget.PT_Tax) != 1) return false;
  }
  if (Check == F_RESIDENTIAL_CHECK) {            //Ratio (RCI) = 2:1:1
    if (City.C_Pop + City.I_Pop == City.R_Pop) {
      if (GetNum(4) == 1) Build = true;
    }
    else if (City.C_Pop + City.I_Pop < City.R_Pop) {
      if (GetNum(5 + City.R_Pop + (City.C_Pop + City.I_Pop)) == 1) Build = true;
    }
    else {
      if (GetNum(4) != 1) Build = true;
    }
  }
  else if (Check == F_COMMERCIAL_CHECK) {        //Ratio 2:1:1
    if (City.R_Pop - City.I_Pop == City.C_Pop) {
      if (GetNum(4) == 2) Build == true;
    }
    else if (City.R_Pop - City.I_Pop < City.C_Pop) {
      if (GetNum(5 + City.C_Pop + (City.R_Pop - City.I_Pop)) == 1) Build = true;
    }
    else {
      if (GetNum(4) != 1) Build = true;
    }
  }
  else if (Check == F_INDUSTRIAL_CHECK) {        //Ratio 2:1:1
    if (City.R_Pop - City.C_Pop == City.I_Pop) {
      if (GetNum(4) == 1) Build == true;
    }
    else if (City.R_Pop - City.C_Pop < City.I_Pop) {
      if (GetNum(5 + City.I_Pop + (City.R_Pop - City.C_Pop)) == 1) Build = true;
    }
    else {
      if (GetNum(4) != 1) Build = true;
    }
  }
  return Build;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Do_All()
{
  int AX, AY;

  for (AY = 0; AY < 80; AY++) {
    for (AX = 0; AX < 80; AX++) {
      MapSquare[AY][AX].Crime = 0;               //Reset Crime
      MapSquare[AY][AX].Pollution = 0;           //Reset Pollution
      MapSquare[AY][AX].Power = false;           //Remove Power
      MapSquare[AY][AX].Sewage = false;          //Remove Sewage
      MapSquare[AY][AX].Water = false;           //Remove Water
      MapSquare[AY][AX].Traffic = 0;             //Reset Traffic
    }
  }

  Do_PSW();                                      //Do Power, Sewage, Water
  Do_Pollution();                                //Do Pollution
  //Do_Crime();                                    //Do Crime
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Do_Crime()
{
  int FX, FY, Total_Add;
  int PX, PY;

  for (FY = 0; FY < 80; FY++) {
    for (FX = 0; FX < 80; FX++) {
      if (MapSquare[FY][FX].Code != 250) {
        if ((Check_Code(FX, FY, F_RESIDENTIAL_CHECK) == true) |
            (Check_Code(FX, FY, F_COMMERCIAL_CHECK) == true)) {
          if (Req[MapSquare[FY][FX].Code].Size == 1) Total_Add = 6;
          else if (Req[MapSquare[FY][FX].Code].Size == 2) Total_Add = 10;
          else if (Req[MapSquare[FY][FX].Code].Size == 3) Total_Add = 15;
          MapSquare[FY][FX].Crime += Total_Add;
        }
        else if (Check_Code(FX, FY, F_INDUSTRIAL_CHECK) == true) {
          if (Req[MapSquare[FY][FX].Code].Size == 1) Total_Add = 10;
          else if (Req[MapSquare[FY][FX].Code].Size == 2) Total_Add = 14;
          else if (Req[MapSquare[FY][FX].Code].Size == 3) Total_Add = 19;
          MapSquare[FY][FX].Crime += Total_Add;
        }
        else if ((Check_Code(FX, FY, F_AIRPORT_CHECK) == true) |
                 (Check_Code(FX, FY, F_SEAPORT_CHECK) == true)) {
          if (Req[MapSquare[FY][FX].Code].Size == 1) Total_Add = 8;
          else if (Req[MapSquare[FY][FX].Code].Size == 2) Total_Add = 12;
          MapSquare[FY][FX].Crime += Total_Add;
        }
      }
      MapSquare[FY][FX].Crime += (MapSquare[FY][FX].Pollution / 10);
      if (Check_Code(FX, FY, 101) == true) {
        for (PY=FY-(City.Budget.PS_Tax/10); PY<FY+(City.Budget.PS_Tax/10)+1; PY++) {
          for (PX=FX-(City.Budget.PS_Tax/10); PX<FX+(City.Budget.PS_Tax/10)+1; PX++) {
            if (Check_Code(PX, PY, F_RANGE_CHECK) == true) {
              Total_Add = 0;
              //Get X Range----------------------\\
              if ((PX - FX >= -3) & (PX - FX <= 3)) Total_Add += 20;
              else if (((PX - FX >= -5) & (PX - FX < -3)) |
                  ((PX - FX > 3) & (PX - FX <= 5))) Total_Add += 15;
              else if (((PX - FX >= -7) & (PX - FX < -5)) |
                  ((PX - FX > 5) & (PX - FX <= 7))) Total_Add += 10;
              else if (((PX - FX >= -9) & (PX - FX < -7)) |
                  ((PX - FX > 7) & (PX - FX <= 9))) Total_Add += 5;
              else if (((PX - FX >= -11) & (PX - FX < -9)) |
                  ((PX - FX > 9) & (PX - FX <= 11))) Total_Add += 3;
              //Get Y Range----------------------\\
              if ((PY - FY >= -3) & (PY - FY <= 3)) Total_Add += 20;
              else if (((PY - FY >= -5) & (PY - FY < -3)) |
                  ((PY - FY > 3) & (PY - FY <= 5))) Total_Add += 15;
              else if (((PY - FY >= -7) & (PY - FY < -5)) |
                  ((PY - FY > 5) & (PY - FY <= 7))) Total_Add += 10;
              else if (((PY - FY >= -9) & (PY - FY < -7)) |
                  ((PY - FY > 7) & (PY - FY <= 9))) Total_Add += 5;
              else if (((PY - FY >= -11) & (PY - FY < -9)) |
                  ((PY - FY > 9) & (PY - FY <= 11))) Total_Add += 3;
              MapSquare[PY][PX].Crime -= Total_Add;
            }
          }
        }
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Do_Pollution()
{
  int FX, FY;
  int Total_Find, Total_Add;
  int RX, RY;

  for (FY = 0; FY < 80; FY++) {
    for (FX = 0; FX < 80; FX++) {

      if (Check_Code(FX, FY, F_RESIDENTIAL_CHECK) == true) {
        Total_Find = Search_Code4(FX, FY, 17);
        Total_Add = (Req[MapSquare[FY][FX].Code].Num / Total_Find) + 1;
        Add_S4_Tiles(Total_Add);
      }
      else if (Check_Code(FX, FY, F_COMMERCIAL_CHECK) == true) {
        Total_Find = Search_Code4(FX, FY, 17);
        Total_Add = (Req[MapSquare[FY][FX].Code].Num / Total_Find) + 1;
        Add_S4_Tiles(Total_Add);
      }
      else if (Check_Code(FX, FY, F_INDUSTRIAL_CHECK) == true) {
        Total_Find = Search_Code4(FX, FY, 17);
        Total_Add = (Req[MapSquare[FY][FX].Code].Num / Total_Find) + 1;
        Add_S4_Tiles(Total_Add);
      }
      else if ((Check_Code(FX, FY, 19) == true) |
               (Check_Code(FX, FY, 22) == true) |
               (Check_Code(FX, FY, 21) == true)) {
        Search_Code4(FX, FY, 17);
        for (RY = 1; RY < 7; RY++) {
          for (RX = 1; RX < 7; RX++) {
            if (S4_Tiles[RY][RX].X > -1) {
              (MapSquare[S4_Tiles[RY][RX].Y][S4_Tiles[RY][RX].X].Traffic += 1) /= 10;
            }
          }
        }
      }
      else if (Check_Code(FX, FY, 109) == true) {
        Total_Find = Search_Code4(FX, FY, 17);
        Total_Add = ((City.R_Pop / 10) / Search_Code2(109)) / Total_Find;
        Add_S4_Tiles(Total_Add);
      }

      if (Check_Code(FX, FY, 17) == true)        //Road
       Add_Pollution(FX, FY, 1, MapSquare[FY][FX].Traffic / 10);
      else if (Check_Code(FX, FY, 37) == true)   //Coal
       Add_Pollution(FX, FY, 6, 17);
      else if (Check_Code(FX, FY, 38) == true)   //Oil
       Add_Pollution(FX, FY, 6, 14);
      else if (Check_Code(FX, FY, 39) == true)   //Gas
       Add_Pollution(FX, FY, 5, 9);
      else if (Check_Code(FX, FY, 40) == true)   //Nuclear
       Add_Pollution(FX, FY, 6, 9);
      else if (Check_Code(FX, FY, 44) == true)   //Fusion
       Add_Pollution(FX, FY, 2, 1);
      else if (Check_Code(FX, FY, 46) == true)   //Treatment
       Add_Pollution(FX, FY, 2, 5);
      else if (Check_Code(FX, FY, 47) == true)   //U.V. Treatment
       Add_Pollution(FX, FY, 3, 3);
      else if (Check_Code(FX, FY, F_AIRPORT_CHECK) == true)
       Add_Pollution(FX, FY, Req[MapSquare[FY][FX].Code].Size, 7);
      else if (Check_Code(FX, FY, F_SEAPORT_CHECK) == true)
       Add_Pollution(FX, FY, Req[MapSquare[FY][FX].Code].Size, 4);
      else if (Check_Code(FX, FY, F_INDUSTRIAL_CHECK) == true) {
        Add_Pollution(FX, FY, Req[MapSquare[FY][FX].Code].Size,
         Req[MapSquare[FY][FX].Code].Num / 10);
      }
      else if (Check_Code(FX, FY, 109) == true)  //Small Park
       Add_Pollution(FX, FY, 4, -20);
      else if (Check_Code(FX, FY, 110) == true)  //Large Park
       Add_Pollution(FX, FY, 5, -30);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Do_PSW()
{
  int XP, YP, Num, Pass;
  IPoint Position;

  City.Tot_Power = 0;                            //Reset Tot Power
  City.Tot_Sewage = 0;                           //Reset Tot Sewage
  City.Tot_Water = 0;                            //Reset Tot Water

  for (Num = 37; Num < 45; Num++) {              //Search for a power plant
    Position = Search_Code3(Num);
    if (Position.X != -1) {                      //Check if found
      MapSquare[Position.Y][Position.X].Power = true;
      City.Tot_Power += Req[Num].Num * Search_Code2(Num);
    }
  }
  for (Num = 46; Num < 48; Num++) {              //Search for a sewage point
    Position = Search_Code3(Num);
    if (Position.X != -1) {
      MapSquare[Position.Y][Position.X].Sewage = true;
      City.Tot_Sewage += Req[Num].Num * Search_Code2(Num);
    }
  }
  Position = Search_Code3(45);                   //Search for a water source
  if (Position.X > -1) {
    MapSquare[Position.Y][Position.X].Water = true;
    City.Tot_Water += Req[45].Num * Search_Code2(45);
  }
  City.Left_Power = City.Tot_Power;
  City.Left_Sewage = City.Tot_Sewage;
  City.Left_Water = City.Tot_Water;
  for (Pass = 0; Pass < 3; Pass++) {             //Make 3 passes
    for (YP = 0; YP < 80; YP++) {
      for (XP = 0; XP < 80; XP++) {
        for (Num = 1; Num < 5; Num++) {
          Position.X = XP;
          Position.Y = YP;
          if (Check_Direction(XP, YP, F_BUILDING_CHECK, Num) == true) {
            Position = S2_IncXY(Position, Num);
            if (MapSquare[Position.Y][Position.X].Power == true) {
              if ((City.Left_Power > 0) & (MapSquare[YP][XP].Power == false)) {
                MapSquare[YP][XP].Power = true;
                City.Left_Power--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Sewage == true) {
              if ((City.Left_Sewage > 0) & (MapSquare[YP][XP].Sewage == false)) {
                MapSquare[YP][XP].Sewage = true;
                City.Left_Sewage--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Water == true) {
              if ((City.Left_Water > 0) & (MapSquare[YP][XP].Water == false)) {
                MapSquare[YP][XP].Water = true;
                City.Left_Water--;
              }
            }
          }
        }
      }
    }
    for (YP = 80; YP > 0; YP--) {
      for (XP = 0; XP < 80; XP++) {
        for (Num = 1; Num < 5; Num++) {
          Position.X = XP;
          Position.Y = YP;
          if (Check_Direction(XP, YP, F_BUILDING_CHECK, Num) == true) {
            Position = S2_IncXY(Position, Num);
            if (MapSquare[Position.Y][Position.X].Power == true) {
              if ((City.Left_Power > 0) & (MapSquare[YP][XP].Power == false)) {
                MapSquare[YP][XP].Power = true;
                City.Left_Power--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Sewage == true) {
              if ((City.Left_Sewage > 0) & (MapSquare[YP][XP].Sewage == false)) {
                MapSquare[YP][XP].Sewage = true;
                City.Left_Sewage--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Water == true) {
              if ((City.Left_Water > 0) & (MapSquare[YP][XP].Water == false)) {
                MapSquare[YP][XP].Water = true;
                City.Left_Water--;
              }
            }
          }
        }
      }
    }
    for (YP = 80; YP < 0; YP--) {
      for (XP = 80; XP < 0; XP--) {
        for (Num = 1; Num < 5; Num++) {
          Position.X = XP;
          Position.Y = YP;
          if (Check_Direction(XP, YP, F_BUILDING_CHECK, Num) == true) {
            Position = S2_IncXY(Position, Num);
            if (MapSquare[Position.Y][Position.X].Power == true) {
              if ((City.Left_Power > 0) & (MapSquare[YP][XP].Power == false)) {
                MapSquare[YP][XP].Power = true;
                City.Left_Power--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Sewage == true) {
              if ((City.Left_Sewage > 0) & (MapSquare[YP][XP].Sewage == false)) {
                MapSquare[YP][XP].Sewage = true;
                City.Left_Sewage--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Water == true) {
              if ((City.Left_Water > 0) & (MapSquare[YP][XP].Water == false)) {
                MapSquare[YP][XP].Water = true;
                City.Left_Water--;
              }
            }
          }
        }
      }
    }
    for (YP = 0; YP < 80; YP++) {
      for (XP = 80; XP > 0; XP--) {
        for (Num = 1; Num < 5; Num++) {
          Position.X = XP;
          Position.Y = YP;
          if (Check_Direction(XP, YP, F_BUILDING_CHECK, Num) == true) {
            Position = S2_IncXY(Position, Num);
            if (MapSquare[Position.Y][Position.X].Power == true) {
              if ((City.Left_Power > 0) & (MapSquare[YP][XP].Power == false)) {
                MapSquare[YP][XP].Power = true;
                City.Left_Power--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Sewage == true) {
              if ((City.Left_Sewage > 0) & (MapSquare[YP][XP].Sewage == false)) {
                MapSquare[YP][XP].Sewage = true;
                City.Left_Sewage--;
              }
            }
            if (MapSquare[Position.Y][Position.X].Water == true) {
              if ((City.Left_Water > 0) & (MapSquare[YP][XP].Water == false)) {
                MapSquare[YP][XP].Water = true;
                City.Left_Water--;
              }
            }
          }
        }
      }
    }
  }
} //Do_PSW
//---------------------------------------------------------------------------
void __fastcall TMainForm::Generate_Map()
{
  int XP, YP, NP;
  int Offset, Width;
  IPoint Position;
  Position.X = 20 + GetNum(30); Position.Y = 0;
  for (YP = 0; YP < 80; YP++) {
    Position.Y = YP;
    Offset = -1 + GetNum(2);
    Width = 4 + GetNum(4);
    Position.X += Offset;
    for (NP = 0; NP < Width; NP++) {
      if (Check_Code(Position.X + NP, Position.Y, F_RANGE_CHECK) == true) {
        MapSquare[Position.Y][Position.X + NP].Code = 12;
      }
    }
  }
  for (YP = 0; YP < 80; YP++) {
    for (XP = 0; XP < 80; XP++) {
      if (MapSquare[YP][XP].Code == 9) {
        if (GetNum(4) != 2) {
          MapSquare[YP][XP].Code = 11;
          MapSquare[YP][XP].Int1 = GetNum(6);
        }
      }
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Generate_Objects(const bool Reset)
{
  int Num, XP, YP;
  for (Num = 1; Num < 50; Num++) {
    Objects[Num].Moving = false;
    Objects[Num].AI_Code = 0;
    Objects[Num].Dir = 0;
    Objects[Num].Cur_Speed = 0;
    Objects[Num].Max_Speed = 0;
    Objects[Num].P_Code = 0;
    Objects[Num].Pos.X = 0;
    Objects[Num].Pos.Y = 0;
  }
  if (Reset == true) return;
  for (YP = 0; YP < 80; YP++) {
    for (XP = 0; XP < 80; XP++) {
      if (Check_Code(XP, YP, 21) == true)
       Add_Object(XP, YP, 20);
      else if (Check_Code(XP, YP, 110) == true)
       Add_Object(XP, YP, 12);
    }
  }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::GetLevel(int X, int Y, int Num)
{
  AnsiString Ret;
  if (Num == 1) {                                //Crime
    if (MapSquare[Y][X].Crime <= 0) Ret = "None";
    else if ((MapSquare[Y][X].Crime > 0) &
             (MapSquare[Y][X].Crime <= 10)) Ret = "Low";
    else if ((MapSquare[Y][X].Crime > 10) &
             (MapSquare[Y][X].Crime <= 20)) Ret = "Medium";
    else if ((MapSquare[Y][X].Crime > 20) &
             (MapSquare[Y][X].Crime <= 30)) Ret = "High";
    else if (MapSquare[Y][X].Crime > 30) Ret = "Very High";
  }
  else if (Num == 2) {                           //Pollution
    if (MapSquare[Y][X].Pollution <= 0) Ret = "None";
    else if ((MapSquare[Y][X].Pollution > 0) &
             (MapSquare[Y][X].Pollution <= 10)) Ret = "Low";
    else if ((MapSquare[Y][X].Pollution > 10) &
             (MapSquare[Y][X].Pollution <= 20)) Ret = "Medium";
    else if ((MapSquare[Y][X].Pollution > 20) &
             (MapSquare[Y][X].Pollution <= 30)) Ret = "High";
    else if (MapSquare[Y][X].Pollution > 30) Ret = "Very High";
  }
  else if (Num == 3) {                           //Power
    if (MapSquare[Y][X].Power == true) Ret = "Yes";
    else if (MapSquare[Y][X].Power == false) Ret = "No";
  }
  else if (Num == 4) {                           //Sewage
    if (MapSquare[Y][X].Sewage == true) Ret = "Yes";
    else if (MapSquare[Y][X].Sewage == false) Ret = "No";
  }
  else if (Num == 5) {                           //Water
    if (MapSquare[Y][X].Water == true) Ret = "Yes";
    else if (MapSquare[Y][X].Water == false) Ret = "No";
  }
  else if (Num == 6) {                           //Traffic
    Ret = IntToStr(MapSquare[Y][X].Traffic);
  }
  return Ret;
} //Get_Level
//---------------------------------------------------------------------------
inline int TMainForm::GetNum(int Limit)
{
  int Num;
  if (Num < 0) return 1;
  Num = random(Limit);                           //Random number generator
  return Num + 1;
} //GetNum
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::GetZoned(int X, int Y)
{
  AnsiString Zone;
  if (Check_Code(X, Y, F_AIRPORT_CHECK) == true) Zone = "Airport";
  else if (Check_Code(X, Y, F_SEAPORT_CHECK) == true) Zone = "Seaport";
  else if (Check_Code(X, Y, F_RESIDENTIAL_CHECK) == true) Zone = "Residential";
  else if (Check_Code(X, Y, F_COMMERCIAL_CHECK) == true) Zone = "Commercial";
  else if (Check_Code(X, Y, F_INDUSTRIAL_CHECK) == true) Zone = "Industrial";
  else Zone = "none";
  return Zone;
} //GetZoned
//---------------------------------------------------------------------------
void __fastcall TMainForm::Move_Objects()
{
  int Temp, Count, Num;
  __OBJECT Obj;
  bool Sorted;

  for (Num = 1; Num < 50; Num++) {               //Total Objects
    Obj = Objects[Num];                          //Set Obj to Objects[Num]
    Sorted = false;
    if (Obj.Moving == true) {                    //Moving?
      Obj.Cur_Speed++;                           //Increase Speed
      if (Obj.Cur_Speed >= Obj.Max_Speed) {      //Move?
        Obj.Cur_Speed = 0;                       //Reset Speed
        MapSquare[Obj.Pos.Y][Obj.Pos.X].Int2 = 0;//Remove Old Position
        if (Obj.AI_Code == 1) {                  //Train
          for (Count = 1; Count < 5; Count++) {
            if (Check_Direction(Obj.Pos.X, Obj.Pos.Y, 20, Count) == true) {
              if (Count != S2_GetOppDirection(Obj.Dir)) {
                if (GetNum(3) != 1) {
                  Obj.Pos = S2_IncXY(Obj.Pos, Count);
                  Obj.Dir = Count;
                  Sorted = true;
                }
              }
            }
            if (Sorted == true) break;
          }
          if (Sorted == false) {
            for (Count = 1; Count < 5; Count++) {
              if (Check_Direction(Obj.Pos.X, Obj.Pos.Y, 20, Count) == true) {
                if (Count != S2_GetOppDirection(Obj.Dir)) {
                  Obj.Pos = S2_IncXY(Obj.Pos, Count);
                  Obj.Dir = Count;
                  break;
                }
              }
            }
          }
        }
        else if (Obj.AI_Code == 2) {
          for (Count = 1; Count < 8; Count++) {
            Temp = GetNum(4);
            if (Check_Direction(Obj.Pos.X, Obj.Pos.Y, 12, Temp) == true) {
              Obj.Pos = S2_IncXY(Obj.Pos, Temp);
              Obj.Dir = Temp;
              Sorted = true;
            }
            if (Sorted == true) break;
          }
          if (Sorted == false) {
            for (Count = 1; Count < 5; Count++) {
              if (Check_Direction(Obj.Pos.X, Obj.Pos.Y, 12, Count) == true) {
                if (Count != S2_GetOppDirection(Obj.Dir)) {
                  Obj.Pos = S2_IncXY(Obj.Pos, Count);
                  Obj.Dir = Count;
                  break;
                }
              }
            }
          }
        }
        MapSquare[Obj.Pos.Y][Obj.Pos.X].Int2 = 130 + Num;
      }
    }
    Objects[Num] = Obj;
  }
} //Move Object
//---------------------------------------------------------------------------
void __fastcall TMainForm::QuerySetup(int X, int Y)
{
  int Temp;

  E_Limit = Speed_Fast;
  if (MapSquare[Y][X].Code == 250) {             //Check for no image
    Temp = X;
    X = MapSquare[Y][X].OrigX;
    Y = MapSquare[Y][Temp].OrigY;
  }
  //Given Name
  Server("ECHO; " + Req[MapSquare[Y][X].Code].Name + "; 273; 0;", false, true);
  if (Req[MapSquare[Y][X].Code].Flag == 1) {
    Server("ECHO; Zoned : " + GetZoned(X, Y) + "; 273; 1;", false, true);
    Server("ECHO; Crime : " + GetLevel(X, Y, 1) + "; 273; 2;", false, true);
    Server("ECHO; Pollution : " + GetLevel(X, Y, 2) + "; 273; 3;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 2) {
    Server("ECHO; Crime : " + GetLevel(X, Y, 1) + "; 273; 1;", false, true);
    Server("ECHO; Pollution : " + GetLevel(X, Y, 2) + "; 273; 2;", false, true);
    Server("ECHO; Power : " + GetLevel(X, Y, 3) + "; 273; 3;", false, true);
    Server("ECHO; Sewage : " + GetLevel(X, Y, 4) + "; 273; 4;", false, true);
    Server("ECHO; Water : " + GetLevel(X, Y, 5) + "; 273; 5;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 3) {
    Server("ECHO; Crime : " + GetLevel(X, Y, 1) + "; 273; 1;", false, true);
    Server("ECHO; Pollution : " + GetLevel(X, Y, 2) + "; 273; 2;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 4) {
    Server("ECHO; Crime : " + GetLevel(X, Y, 1) + "; 273; 1;", false, true);
    Server("ECHO; Pollution : " + GetLevel(X, Y, 2) + "; 273; 2;", false, true);
    Server("ECHO; Cars / Min : "+ GetLevel(X, Y, 6) + "; 273; 3;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 5) {
    Temp = Search_Code2(17) / 10 * (Search_Code2(MapSquare[Y][X].Code) -1);
    Server("ECHO; Passengers : "  + IntToStr(Temp) + " / day; 273; 1;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 6) {
    Server("ECHO; Capacity : " + IntToStr(Req[MapSquare[Y][X].Code].Num / 3) + "MW; 273; 1;", false, true);
    Server("ECHO; Remaining : " + IntToStr(City.Left_Power/3) + "MW; 273; 2;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 8) {
    Server("ECHO; Zoned : " + GetZoned(X, Y) + "; 273; 1;", false, true);
    Server("ECHO; Crime : " + GetLevel(X, Y, 1) + "; 273; 2;", false, true);
    Server("ECHO; Pollution : " + GetLevel(X, Y, 2) + "; 273; 3;", false, true);
    Server("ECHO; Power : " + GetLevel(X, Y, 3) + "; 273; 4;", false, true);
    Server("ECHO; Sewage : " + GetLevel(X, Y, 4) + "; 273; 5;", false, true);
    Server("ECHO; Water : " + GetLevel(X, Y, 5) + "; 273; 6;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 9) {
    Server("ECHO; Officers : ; 273; 1;", false, true);
    Server("ECHO; Crimes Reported : ; 273; 2;", false, true);
    Server("ECHO; Arrests : ; 273; 3;", false, true);
    Server("ECHO; Anual Cost : " + IntToStr(3 * UpDown2->Position) + "; 273; 4;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 10) {
    Server("ECHO; Fire Fighters : ; 273; 1;", false, true);
    Server("ECHO; Fire Engines : ; 273; 2;", false, true);
    Server("ECHO; Responce Time : ; 273; 3;", false, true);
    Server("ECHO; Anual Cost : " + IntToStr(2.5 * UpDown3->Position) + "; 273; 4;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 11) {
    Server("ECHO; Beds : ; 273; 1;", false, true);
    Server("ECHO; Patients : ; 273; 2;", false, true);
    Server("ECHO; Doctors : ; 273; 3;", false, true);
    Server("ECHO; Anual Cost : " + IntToStr(3 * UpDown4->Position) + "; 273; 4;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 12) {
    Temp = (City.R_Pop + 1 / 2) / Search_Code2(MapSquare[Y][X].Code);
    Server("ECHO; Capacity : " + IntToStr(Req[MapSquare[Y][X].Code].Num) + "; 273; 1;", false, true);
    Server("ECHO; Students : " + IntToStr(Temp) + "; 273; 2;", false, true);
    Server("ECHO; Teachers : " + IntToStr(City.Budget.Ed_Tax) + "; 273; 3;", false, true);
    Server("ECHO; Class Size : " + IntToStr(Temp / City.Budget.Ed_Tax) + "; 273; 4;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 13) {
    Server("ECHO; Attendance : ; 273; 1;", false, true);
    Server("ECHO; Books : ; 273; 2;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 14) {
    Server("ECHO; Attendance : ; 273; 1;", false, true);
    Server("ECHO; Exibits : ; 273; 2;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 15) {
    Temp = Search_Code2(109);
    Server("ECHO; Attendance : " + IntToStr((City.R_Pop / 10) / Temp) + "; 273; 1;", false, true);
    Server("ECHO; Acres : " + IntToStr(Temp * 4) + "; 273; 2;", false, true);
    Server("ECHO; Employes : " + IntToStr(Temp * 10) + "; 273; 3;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 16) {
    Temp = Search_Code2(110) * (18 + GetNum(5));
    Server("ECHO; Boats : " + IntToStr(Temp) + "; 273; 1;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 17) {
    Server("ECHO; Capacity : " + IntToStr(Req[MapSquare[Y][X].Code].Num) + "; 273; 1;", false, true);
    Server("ECHO; Remaining : " + IntToStr(City.Left_Water) + "; 273; 2;", false, true);
  }
  else if (Req[MapSquare[Y][X].Code].Flag == 18) {
    Server("ECHO; Capacity : " + IntToStr(Req[MapSquare[Y][X].Code].Num) + "; 273; 1;", false, true);
    Server("ECHO; Remaining : " + IntToStr(City.Left_Sewage) + "; 273; 2;", false, true);
  }
} //QuerySetup
//---------------------------------------------------------------------------
void __fastcall TMainForm::Reset_Tile(int X, int Y, const int New_Code)
{
  MapSquare[Y][X].Code = New_Code;
  MapSquare[Y][X].OrigX = 0;
  MapSquare[Y][X].OrigY = 0;
  MapSquare[Y][X].Int1 = 0;
  MapSquare[Y][X].Int2 = 0;
  MapSquare[Y][X].Power = false;
  MapSquare[Y][X].Sewage = false;
  MapSquare[Y][X].Water = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Reset_Variables()
{
  City.Budget.PT_Tax = 25;
  City.Budget.PS_Tax = 100;
  City.Budget.FS_Tax = 100;
  City.Budget.Ho_Tax = 100;
  City.Budget.Ed_Tax = 100;
  City.Budget.Tr_Tax = 100;
  City.Status = 1;
  E_Limit = 0; E_Time = 0;
  CurPos.StartXY.X = -1;
  Generate_Objects(true);                        //Reset Objects
}
//---------------------------------------------------------------------------
IPoint __fastcall TMainForm::Search_Code(int SX, int SY, int Find, int Rad)
{
  //Nearest in Radius----------------------------\\
  IPoint Location = {-1, -1};
  bool Found = false;
  int XP, YP;
  for (YP = SY - (Rad); YP < SY + Rad + 1; YP++) {
    for (XP = SX - (Rad); XP < SX + Rad + 1; XP++) {
      if ((XP != SX) & (YP != SY) & (Check_Code(XP, YP, Find) == true)) {
        Found = true;
        Location.X = XP; Location.Y = YP;
        break;
      }
    }
    if (Found == true) break;
  }
  if (Found == false) {
    Location.X = -1; Location.Y = -1;
  }
  return Location;
}
//---------------------------------------------------------------------------
inline int TMainForm::Search_Code2(const int Find)
{
  //Total Amount---------------------------------\\
  int Total = 0;
  int XP, YP;
  for (YP = 0; YP < 80; YP++) {
    for (XP = 0; XP < 80; XP++) {
      if (Check_Code(XP, YP, Find) == true) {
        Total++;
      }
    }
  }
  return Total;
}
//---------------------------------------------------------------------------
IPoint __fastcall TMainForm::Search_Code3(const int Find)
{
  //First Location-------------------------------\\
  IPoint Pos = {-1, -1};
  int XP, YP;
  bool Found = false;
  for (YP = 0; YP < 80; YP++) {
    for (XP = 0; XP < 80; XP++) {
      if (Check_Code(XP, YP, Find) == true) {
        Pos.X = XP;
        Pos.Y = YP;
        Found = true;
        break;
      }
      if (Found == true) break;
    }
  }
  return Pos;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::Search_Code4(int SX, int SY, const int Find)
{
  //Distance 3x3 stored in an array--------------\\
  int Total = 1, XX, YY;
  for (YY = SY - 3; YY < SY + 4; YY++) {
    for (XX = SX - 3; XX < SX + 4; XX++) {
      if (Check_Code(XX, YY, Find) == true) {
        S4_Tiles[(YY - SY) + 3][(XX - SX) + 3].X = XX;
        S4_Tiles[(YY - SY) + 3][(XX - SX) + 3].Y = YY;
        Total++;
      }
      else {
        S4_Tiles[(YY - SY) + 3][(XX - SX) + 3].X = -1;
        S4_Tiles[(YY - SY) + 3][(XX - SX) + 3].Y = -1;
      }
    }
  }
  return Total;
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::Search_Code5(int SX, int SY, const int Find, int Limit)
{
  //Searches for the closest position------------\\
  int Radius;
  int Distance = 0;                              //Assume not found
  if (Search_Code2(Find) <= 1) return 0;         //Check if find exists
  for (Radius = 1; Radius < 80; Radius++) {
    if (Radius >= Limit) break;                  //Check Limit
    if (Search_Code(SX, SY, Find, Radius).X > -1) {
      Distance = Radius;
      break;
    }
  }
  return Distance;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::Set_Code(int X, int Y, int Num, int Size, int Code)
{
  bool Ret;
  int CX, CY;
  if (Size < 1) return false;
//Size 1-----------------------------------------\\
  if (Size == 1) {
    if (Check4_ClearTerrain(X, Y, Code) == true) {
      MapSquare[Y][X].Code = Num;
      Ret = true;
    }
    else Ret = false;
  }
//Size 2 / 3 / 4---------------------------------\\
  else if ((Size == 2) | (Size == 3) | (Size == 4)) {
    Ret = true;
    for (CX = X; CX < X + Size; CX++) {
      for (CY = Y; CY < Y + Size; CY++) {
        if (Check4_ClearTerrain(CX, CY, Code) == false) return false;
      }
    }
    //return false;
    for (CX = X; CX < X + Size; CX++) {
      for (CY = Y; CY < Y + Size; CY++) {
        Reset_Tile(CX, CY, 250);
        MapSquare[CY][CX].OrigX = X;
        MapSquare[CY][CX].OrigY = Y;
      }
    }
    MapSquare[Y][X].Code = Num;
    MapSquare[Y][X].OrigX = 0;
    MapSquare[Y][X].OrigY = 0;
  }
//Size 5-----------------------------------------\\
  else if (Size == 5) {                          //Move East
    Ret = true;
    for (CX = X; CX < X + 5; CX++)
     if (Check_Code(CX, Y, Code) == false) return false;
    for (CX = X; CX < X + 5; CX++) {
      Reset_Tile(CX, Y, Num);
      MapSquare[Y][CX].Int1 = 5;
    }
  }
//Size 6-----------------------------------------\\
  else if (Size == 6) {                          //Move South
    Ret = true;
    for (CY = Y; CY < Y + 5; CY++)
     if (Check_Code(X, CY, Code) == false) return false;
    for (CY = Y; CY < Y + 5; CY++) {
      Reset_Tile(X, CY, Num);
      MapSquare[CY][X].Int1 = 6;
    }
  }
  return Ret;
} //Set_Code
//---------------------------------------------------------------------------
void TMainForm::Setup_Screen()
{
  New_GB->Visible = false;
  Title_I->Visible = false;
  Panel1->Visible = true;
  Tools_GB->Visible = true;
  Horz_SB->Visible = true;                       //Make Scroll bars visible
  Vert_SB->Visible = true;
  Panel1->Caption = City.Name;                   //Write name
  Refresh();                                     //Refresh Screen
  GraphicsDraw();
  Server("SPEED; " + IntToStr(Speed_Med) + ";", false, true);
  Server("SET_TOOL; 1; 9; Bulldoze; 10; BULLDOZE.WAV;", false, true);
}
//---------------------------------------------------------------------------
int __fastcall TMainForm::SplitComm(AnsiString StartStr)
{
  int ASPos, CPos = 1, Temp;
  AnsiString TempComms[10];
  for (Temp = 1; Temp < 10; Temp++)              //Clear Comms array
   Comms[Temp].Delete(1, Comms[Temp].Length());
  if (StartStr.Length() == 0) return -1;         //If no String
  StartStr.Trim();                               //Clear Spaces
  for (ASPos = 0; ASPos < StartStr.Length(); ASPos++) {
    if (StartStr.IsDelimiter("#", ASPos) == true) break;
    else if (StartStr.IsDelimiter(";", ASPos) == true) CPos++;
    else TempComms[CPos] += StartStr.c_str()[ASPos];
  }
  for (Temp = 1; Temp < 10; Temp++) {
    TempComms[Temp].Trim();
    for (ASPos = 0; ASPos < TempComms[Temp].Length() - 1; ASPos++)
      Comms[Temp] += TempComms[Temp].c_str()[ASPos];
  }
  return CPos;
} //SplitComm
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormActivate(TObject *Sender)
{
  MainForm->Visible = true;
  if (Play_Videos == true) {
    AGS_Video->FileName = szDrive + "\\Graphics\\ags.avi";
    AGS_Video->Open();
    AGS_Video->Play();
    ::Sleep(1600);
    CityB_Video->FileName = szDrive + "\\Graphics\\city_title.avi";
    CityB_Video->Open();
    CityB_Video->Play();
    ::Sleep(3400);
  }         
  AGS_Back->Visible = false;
  CityB_Back->Visible = false;
  Title_I->Picture->LoadFromFile(szDrive + "\\Graphics\\title.bmp");
  Title_I->Width = 400;
  Title_I->Height = 400;
  Title_I->Left = 120;
  Title_I->Top = 20;
  Title_I->Visible = true;
  Start_GB->Visible = true;
  ::delete AGS_Video;                            //Free up the memory
  ::delete AGS_Back;
  ::delete CityB_Video;
  ::delete CityB_Back;

}
//---------------------------------------------------------------------------




