
//Start of "City.h"----------------------------------------------------------
#ifndef CityH
#define CityH
//Includes-------------------------------------------------------------------
#include <Buttons.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <DDraw.h>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <FStream.h>
#include <GVar.h>
#include <Menus.hpp>
#include <MMSystem.h>
#include <MPlayer.hpp>
#include <StdCtrls.hpp>
#include <StdLib.h>
#include <String.h>
#include "AEngine7.h"
#include "AWaveSound2.h"
#include "E7_DDraw.h"
//Consts-----------------------------------------\\
const int MapWidth = 80;
const int MapHeight = 80;
const int Max_Draw_X = 13;
const int Max_Draw_Y = 25;
const int Speed_Slow = 10000;
const int Speed_Med = 6000;
const int Speed_Fast = 2000;
const int TotPics = 202;                         //Total Pictures
const int XTP[13] =                              //Tiles X Position
 {0, 60, 120, 180, 240, 300, 360, 420, 480, 540, 600, 660, 720};
const int YTP[24] =                              //Tiles Y Position
 {45, 60, 75, 90, 105, 120, 135, 150, 165, 180, 195, 210, 225, 240, 255,
  270, 285, 300, 315, 330, 345, 360, 375};

//Text-------------------------------------------\\
const AnsiString Months[13] =
 {"Null", "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
//Text Positions---------------------------------\\
const int TTP[8] = {365, 380, 395, 410, 425, 440, 455, 470};
const int F_RANGE_CHECK = 0xFF1;
const int F_RESIDENTIAL_CHECK = 0xFF2;
const int F_COMMERCIAL_CHECK = 0xFF3;
const int F_INDUSTRIAL_CHECK = 0xFF4;
const int F_AIRPORT_CHECK = 0xFF5;
const int F_SEAPORT_CHECK = 0xFF6;
const int F_BUILDING_CHECK = 0xFF7;
const int F_POWER_CHECK = 0xFF8;
const int F_POWER_LINE = 0xFF9;

//Classes--------------------------------------------------------------------
class TMainForm;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
  __published:                                   //IDE-managed Components
  /*****************/
  /*Console        */
  /*DDraw          */
  /*File I/O       */
  /*Main Menu      */
  /*New Group Box  */
  /*Start Group Box*/
  /*Tools Group Box*/
  /*Other          */
  /*****************/
  //Console--------------------------------------\\
  TPanel *Console_P;
  TEdit *C_Input_E;
    TE_DDraw *DD;
    TE_DDSurface *DDScene;
  TOpenDialog *OpenDialog;
  TSaveDialog *SaveDialog;
  //Main Menu------------------------------------\\
  TMainMenu *MainMenu;
  TMenuItem *M_File;
  TMenuItem *F_NewCity;
  TMenuItem *F_LoadCity;
  TMenuItem *N1;
  TMenuItem *F_Save;
  TMenuItem *N2;
  TMenuItem *F_Exit;
  //---------------------------------------------\\
  TMenuItem *M_Speed;
  TMenuItem *S_Pause;
  TMenuItem *S_Slow;
  TMenuItem *S_Medium;
  TMenuItem *S_Fast;
  //---------------------------------------------\\
  TMenuItem *M_Options;
  TMenuItem *O_CDAudio;
  TMenuItem *O_SoundFX;
  //---------------------------------------------\\
  TMenuItem *M_Windows;
  TMenuItem *W_Console;
  TMenuItem *W_Tools;
  //New Group Box--------------------------------\\
  TGroupBox *New_GB;
  TEdit *N_Name_E;
  TRadioButton *N_Easy_RB;
  TRadioButton *N_Hard_RB;
  TButton *N_Ok_B;
  //---------------------------------------------\\
  TGroupBox *Start_GB;
  TRadioButton *S_New_RB;
  TRadioButton *S_Load_RB;
  TButton *S_Ok_B;
  TButton *S_Exit_B;
  //Tools Group Box------------------------------\\
  TGroupBox *Tools_GB;
  TSpeedButton *Bulldoze_SB;
  //Land Scape-----------------------------------\\
  TSpeedButton *Landscape_SB;
  TPopupMenu *Landscape_PM;
  TMenuItem *L_Lake;
  TMenuItem *L_Trees;
  //Gifts----------------------------------------\\
  TSpeedButton *Gifts_SB;
  TPopupMenu *Gifts_PM;
  TMenuItem *G_CityHall;
  TMenuItem *G_Fountain;
  TMenuItem *G_Statue;
  TMenuItem *G_YourHouse;
  //Road-----------------------------------------\\
  TSpeedButton *Road_SB;
  TPopupMenu *Road_PM;
  TMenuItem *R_Road;
  TMenuItem *R_MotorWay;
  TMenuItem *R_BusStation;
  //Rail-----------------------------------------\\
  TSpeedButton *Rail_SB;
  TPopupMenu *Rail_PM;
  TMenuItem *R_Rail;
  TMenuItem *R_Station;
  TMenuItem *N3;
  TMenuItem *R_SubStation;
  //Ports----------------------------------------\\
  TSpeedButton *Ports_SB;
  TPopupMenu *Ports_PM;
  TMenuItem *P_Air;
  TMenuItem *P_Sea;
  //Power----------------------------------------\\
  TSpeedButton *Power_SB;
  TPopupMenu *Power_PM;
  TMenuItem *P_PowerLine;
  TMenuItem *P_Coal;
  TMenuItem *P_Oil;
  TMenuItem *P_Gas;
  TMenuItem *P_Nuclear;
  TMenuItem *P_Wind;
  TMenuItem *P_Solar;
  TMenuItem *P_MicroWave;
  //Water----------------------------------------\\
  TSpeedButton *Pipes_SB;
  TSpeedButton *Sewage_SB;
  TPopupMenu *Sewage_PM;
  TMenuItem *S_Treatment;
  TMenuItem *S_UVTreatment;
  //Residentual----------------------------------\\
  TSpeedButton *Residential_SB;
  TPopupMenu *Residential_PM;
  TMenuItem *R_LDensity;
  TMenuItem *R_HDensity;
  //Commercial-----------------------------------\\
  TSpeedButton *Commercial_SB;
  TPopupMenu *Commercial_PM;
  TMenuItem *C_LDensity;
  TMenuItem *C_HDensity;
  //Industrial-----------------------------------\\
  TSpeedButton *Industrial_SB;
  TPopupMenu *Industrial_PM;
  TMenuItem *I_LDensity;
  TMenuItem *I_HDensity;
  //Religion-------------------------------------\\
  TSpeedButton *Religion_SB;
  TPopupMenu *Religion_PM;
  TMenuItem *R_Church;
  TMenuItem *R_Cathedral;
  //Recreation-----------------------------------\\
  TSpeedButton *Recreation_SB;
  TPopupMenu *Recreation_PM;
  TMenuItem *R_LargePark;
  TMenuItem *R_SmallPark;
  TMenuItem *R_Marina;
  TMenuItem *R_Stadium;
  //Services-------------------------------------\\
  TSpeedButton *Services_SB;
  TPopupMenu *Services_PM;
  TMenuItem *S_Police;
  TMenuItem *S_Fire;
  TMenuItem *S_Hospital;
  //Education------------------------------------\\
  TSpeedButton *Education_SB;
  TPopupMenu *Education_PM;
  TMenuItem *E_School;
  TMenuItem *E_College;
  TMenuItem *E_Library;
    TMenuItem *E_Museum;
  TSpeedButton *Query_SB;
  //Emergancy------------------------------------\\
  TSpeedButton *Emergancy_SB;
  TPopupMenu *Emergancy_PM;
  TMenuItem *E_Police;
  TMenuItem *E_Fire;
  //---------------------------------------------\\
  TSpeedButton *RCCWSB;
  TSpeedButton *RCWiSB;
  TSpeedButton *Centre_SB;
  //Other----------------------------------------\\
  TPanel *Panel1;
  TScrollBar *Horz_SB;
  TScrollBar *Vert_SB;
  TTimer *Clock;
    TPanel *Budget_P;
    TLabel *B_City_Name;
    TLabel *B_Year;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;
    TLabel *Label6;
    TUpDown *UpDown1;
    TEdit *Edit1;
    TUpDown *UpDown2;
    TUpDown *UpDown3;
    TUpDown *UpDown4;
    TUpDown *UpDown5;
    TUpDown *UpDown6;
    TEdit *Edit2;
    TEdit *Edit3;
    TEdit *Edit4;
    TEdit *Edit5;
    TEdit *Edit6;
    TButton *B_Ok_B;
    TLabel *B_PT_L;
    TLabel *B_PS_L;
    TLabel *B_FS_L;
    TLabel *B_Ho_L;
    TLabel *B_Ed_L;
    TLabel *B_Tr_L;
    TLabel *B_Gross_L;
    TLabel *B_Net_L;
    TMenuItem *O_A_Budget;
    TMediaPlayer *AGS_Video;
    TPanel *AGS_Back;
    TMediaPlayer *CityB_Video;
    TPanel *CityB_Back;
    TImage *Title_I;
    TMemo *C_Memo;
    TMenuItem *M_Help;
    TMenuItem *H_About;
    TRadioButton *S_Sound_RB;
  void __fastcall C_Input_EKeyPress(TObject *Sender, char &Key);
  //Form-----------------------------------------\\
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
   int X, int Y);
  void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
   TShiftState Shift, int X, int Y);
  void __fastcall MouseDrag(IPoint Start, IPoint Drop);
  //Main Menu------------------------------------\\
  void __fastcall F_NewCityClick(TObject *Sender);
  void __fastcall F_LoadCityClick(TObject *Sender);
  void __fastcall F_SaveClick(TObject *Sender);
  void __fastcall F_ExitClick(TObject *Sender);
  //---------------------------------------------\\
  void __fastcall S_PauseClick(TObject *Sender);
  void __fastcall S_SlowClick(TObject *Sender);
  void __fastcall S_MediumClick(TObject *Sender);
  void __fastcall S_FastClick(TObject *Sender);
  void __fastcall O_CDAudioClick(TObject *Sender);
  void __fastcall O_SoundFXClick(TObject *Sender);
  //---------------------------------------------\\
  void __fastcall W_ConsoleClick(TObject *Sender);
  void __fastcall W_ToolsClick(TObject *Sender);
  //New Group-Box--------------------------------\\
  void __fastcall N_Ok_BClick(TObject *Sender);
  //Start Group Box------------------------------\\
  void __fastcall S_Ok_BClick(TObject *Sender);
  void __fastcall S_Exit_BClick(TObject *Sender);
  void __fastcall Bulldoze_SBClick(TObject *Sender);
  //Land Scape-----------------------------------\\
  void __fastcall Landscape_SBClick(TObject *Sender);
  void __fastcall L_LakeClick(TObject *Sender);
  void __fastcall L_TreesClick(TObject *Sender);
  //Gifts----------------------------------------\\
  void __fastcall Gifts_SBClick(TObject *Sender);
  void __fastcall G_CityHallClick(TObject *Sender);
  void __fastcall G_FountainClick(TObject *Sender);
  void __fastcall G_StatueClick(TObject *Sender);
  void __fastcall G_YourHouseClick(TObject *Sender);
  //Road-----------------------------------------\\
  void __fastcall Road_SBClick(TObject *Sender);
  void __fastcall R_RoadClick(TObject *Sender);
  void __fastcall R_MotorWayClick(TObject *Sender);
  void __fastcall R_BusStationClick(TObject *Sender);
  //Rail-----------------------------------------\\
  void __fastcall Rail_SBClick(TObject *Sender);
  void __fastcall R_RailClick(TObject *Sender);
  void __fastcall R_StationClick(TObject *Sender);
  void __fastcall R_SubStationClick(TObject *Sender);
  //Ports----------------------------------------\\
  void __fastcall Ports_SBClick(TObject *Sender);
  void __fastcall P_AirClick(TObject *Sender);
  void __fastcall P_SeaClick(TObject *Sender);
  //Power----------------------------------------\\
  void __fastcall Power_SBClick(TObject *Sender);
  void __fastcall P_PowerLineClick(TObject *Sender);
  void __fastcall P_CoalClick(TObject *Sender);
  void __fastcall P_OilClick(TObject *Sender);
  void __fastcall P_GasClick(TObject *Sender);
  void __fastcall P_NuclearClick(TObject *Sender);
  void __fastcall P_WindClick(TObject *Sender);
  void __fastcall P_SolarClick(TObject *Sender);
  void __fastcall P_MicroWaveClick(TObject *Sender);
  //Pipes----------------------------------------\\
  void __fastcall Pipes_SBClick(TObject *Sender);
  void __fastcall Sewage_SBClick(TObject *Sender);
  void __fastcall S_TreatmentClick(TObject *Sender);
  void __fastcall S_UVTreatmentClick(TObject *Sender);
  //Residentual----------------------------------\\
  void __fastcall Residential_SBClick(TObject *Sender);
  void __fastcall R_LDensityClick(TObject *Sender);
  void __fastcall R_HDensityClick(TObject *Sender);
  //Commercial-----------------------------------\\
  void __fastcall Commercial_SBClick(TObject *Sender);
  void __fastcall C_LDensityClick(TObject *Sender);
  void __fastcall C_HDensityClick(TObject *Sender);
  //Industrial-----------------------------------\\
  void __fastcall Industrial_SBClick(TObject *Sender);
  void __fastcall I_LDensityClick(TObject *Sender);
  void __fastcall I_HDensityClick(TObject *Sender);
  //Religion-------------------------------------\\
  void __fastcall Religion_SBClick(TObject *Sender);
  void __fastcall R_ChurchClick(TObject *Sender);
  void __fastcall R_CathedralClick(TObject *Sender);
  //Recreation-----------------------------------\\
  void __fastcall Recreation_SBClick(TObject *Sender);
  void __fastcall R_SmallParkClick(TObject *Sender);
  void __fastcall R_LargeParkClick(TObject *Sender);
  void __fastcall R_MarinaClick(TObject *Sender);
  void __fastcall R_StadiumClick(TObject *Sender);
  //Services-------------------------------------\\
  void __fastcall Services_SBClick(TObject *Sender);
  void __fastcall S_PoliceClick(TObject *Sender);
  void __fastcall S_FireClick(TObject *Sender);
  void __fastcall S_HospitalClick(TObject *Sender);
  //Education------------------------------------\\
  void __fastcall Education_SBClick(TObject *Sender);
  void __fastcall E_SchoolClick(TObject *Sender);
  void __fastcall E_CollegeClick(TObject *Sender);
  void __fastcall E_LibraryClick(TObject *Sender);
  void __fastcall E_MuseumClick(TObject *Sender);
  //Query----------------------------------------\\
  void __fastcall Query_SBClick(TObject *Sender);
  //Emergancy------------------------------------\\
  void __fastcall Emergancy_SBClick(TObject *Sender);
  void __fastcall E_PoliceClick(TObject *Sender);
  void __fastcall E_FireClick(TObject *Sender);
  //---------------------------------------------\\
  void __fastcall RCCWSBClick(TObject *Sender);
  void __fastcall RCWiSBClick(TObject *Sender);
  void __fastcall Centre_SBClick(TObject *Sender);
  //Other----------------------------------------\\
  void __fastcall ClockTimer(TObject *Sender);
  void __fastcall C_Input_EKeyDown(TObject *Sender, WORD &Key,
   TShiftState Shift);
  void __fastcall GameKeyBown(TObject *Sender, WORD &Key,
          TShiftState Shift);
  void __fastcall B_Ok_BClick(TObject *Sender);
  void __fastcall O_A_BudgetClick(TObject *Sender);
  void __fastcall FormActivate(TObject *Sender);

  void __fastcall H_AboutClick(TObject *Sender);

    
    
private:	                                     //User declarations
  __MAPSQUARE MapSquare[MapHeight][MapWidth];    //MapSquare Array
  __CURSORPOS CurPos;                            //CurPos Array
  __CITY City;                                   //City Array
//Variables--------------------------------------\\
  AnsiString Comms[10];                          //Commands
  int E_Time;                                    //Echo Controls
  int E_Limit;                                   //Echo time Limit
  int Sprite_No;                                 //Sprite Counter
  IPoint S4_Tiles[7][7];                         //Tiles for Search 4
  IPoint PopUp_Position;                         //Popup Position

//Methods----------------------------------------\\
//Draw-------------------------------------------\\
  bool __fastcall Add_Tile(int, int, IPoint, int);
  void __fastcall GraphicsDraw(void);
  void __fastcall Draw_RRR(int, int, int, int, int);
  void __fastcall Draw_RP(int, int, int, int);
  void __fastcall Draw_MWay(int, int);
  void __fastcall Draw_Lake(int, int);
  void __fastcall Draw_PowerLine(int, int);
  void __fastcall Draw_Tree(int, int);
  void __fastcall Draw_Tile(int, int, int, RECT);
//Other------------------------------------------\\
  bool __fastcall Add_Object(int, int, int);
  void __fastcall Add_Pollution(int, int, int, int);
  void __fastcall Add_S4_Tiles(int);
  void __fastcall Budget_Setup(void);
  void __fastcall Budget_False_Setup(void);
  void __fastcall Build_Airport(int, int);
  void __fastcall Build_HResidential(int, int);
  void __fastcall Build_HCommercial(int, int);
  void __fastcall Build_HIndustrial(int, int);
  void __fastcall Build_LDensity(int, int, int);
  void __fastcall Build_Seaport(int, int);
  inline bool Check4_ClearTerrain(int, int, int);
  inline bool Check_Code(int, int, int);
  inline bool Check_Direction(const int, const int, int, int);
  void __fastcall Check_Status(void);
  void __fastcall Check_Years(void);
  bool __fastcall Check_Zone(int, int, const int);
  bool __fastcall Check_Zone_Pop(const int);
  void __fastcall Do_All();
  void __fastcall Do_Crime(void);
  void __fastcall Do_Pollution(void);
  void __fastcall Do_PSW(void);
  void __fastcall Generate_Map(void);
  void __fastcall Generate_Objects(const bool);
  AnsiString __fastcall GetLevel(int, int, int);
  inline int GetNum(int Limit);
  AnsiString __fastcall GetZoned(int, int);
  void __fastcall Move_Objects(void);
  void __fastcall QuerySetup(int, int);
  void __fastcall Reset_Tile(int, int, const int);
  void __fastcall Reset_Variables(void);
  IPoint __fastcall Search_Code(int, int, int, int);
  inline int Search_Code2(int);
  IPoint __fastcall Search_Code3(const int);
  int __fastcall Search_Code4(int, int, const int);
  int __fastcall Search_Code5(int, int, const int, int);
  bool __fastcall Set_Code(int, int, int, int, int);
  void Setup_Screen();
  int __fastcall SplitComm(AnsiString);

public:		                                     //User declarations
  __fastcall TMainForm(TComponent* Owner);       //MainForm Setup
  __fastcall ~TMainForm();                       //MainForm Close

  void __fastcall Server(AnsiString Comm1, bool C_Show, bool szCity);

  LPDIRECTDRAWSURFACE7 lpDDS[TotPics];            //Building images
  LPDIRECTDRAWSURFACE7 lpDDS_Blank;               //Blank image
  LPDIRECTDRAWSURFACE7 lpDDS_Cursor[5];           //Cursor
  LPDIRECTDRAWSURFACE7 lpDDS_Screen;
  IPoint TilePos[MapHeight * 2 + 2][MapWidth];   //Tile Positions
  __REQUIREMENTS Req[TotPics];                   //Req Array
  __OBJECT Objects[50];                          //Object
  IPoint Draw_Square[Max_Draw_X * Max_Draw_Y];   //Graphics
  bool Tiles_Done[Max_Draw_Y][Max_Draw_X];
  bool Play_Videos;
  AnsiString szDrive;
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
//End of "City.h"------------------------------------------------------------
#endif

