/***************************************/
/*Program Name  : CD Utilities         */
/*File Name     : cdutils.cpp          */
/*Author        : Ivan Wright          */
/*Updated       : 26/12/99             */
/*Version       : 1.1                  */
/***************************************/
//---------------------------------------------------------------------------
#include "CDUtils.h"
//---------------------------------------------------------------------------
namespace TCD {
  AnsiString CommReturn;                         //Command Return
  LPTSTR mciReturn;                              //mci Return
  BOOL CD_Active;                                //CD Active
  eCDModes CDMode;                               //CD State (partly obselete)
//---------------------------------------------------------------------------
void __fastcall CDClose()
{
  if (CD_Active == TRUE) {                       //If still active
    CDStop();                                    //Stop the CD
    mciSendString("close cdaudio", mciReturn, lstrlen(mciReturn), NULL);
    if ((DWORD) mciReturn != 0) ShowMessage("Error closing CD Audio");
    CD_Active == FALSE;                          //CD Audio inactive
  }
}
//---------------------------------------------------------------------------
void __fastcall CDEject()
{
  CDStop();                                      //Stop the CD
  mciSendString("set cdaudio door open", mciReturn, lstrlen(mciReturn), NULL);
  if ((DWORD) mciReturn != 0) ShowMessage("Can't eject CD");
  CommReturn = "CD door open";
}
//---------------------------------------------------------------------------
eCDModes CDGetMode()
{
  return CDMode;
}
//---------------------------------------------------------------------------
void __fastcall CDInit()
{
  CDMode = cdNotReady;                           //Assume no CD Audio
  mciSendString("open cdaudio", mciReturn, lstrlen(mciReturn), NULL);
  if ((DWORD) mciReturn != 0) {                  //No CD Audio
    CD_Active = FALSE;
    CommReturn = "CD Audio Not initialised";
  }
  else {
    CD_Active = TRUE;                            //CD Audio Active
    mciSendString("set cdaudio time format tmsf", mciReturn,
     lstrlen(mciReturn), NULL);                  //Set time format
    if ((DWORD) mciReturn == 0) {                //Check for error
      CDMode = cdStoped;                         //Set mode to stoped
      CommReturn = "CD Audio initialised";
    }
    else CommReturn = "CD Audio Not initialised";
  }
}
//---------------------------------------------------------------------------
void __fastcall CDInject()
{
  mciSendString("set cdaudio door closed", mciReturn, lstrlen(mciReturn), NULL);
  if ((DWORD) mciReturn != 0) ShowMessage("Can't inject CD");
  CommReturn = "CD door closed";
}
//---------------------------------------------------------------------------
void __fastcall CDPause()
{
  if (CDMode == cdPlaying) {
    mciSendString("pause cdaudio", mciReturn, lstrlen(mciReturn), NULL);
    if ((DWORD) mciReturn != 0) ShowMessage("Error pausing");
    CDMode = cdPaused;
    CommReturn = "CD paused";
  }
  else if (CDMode == cdPaused) {
    mciSendString("play cdaudio", mciReturn, lstrlen(mciReturn), NULL);
    if ((DWORD) mciReturn != 0) ShowMessage("Error playing");
    CDMode = cdPlaying;
    CommReturn = "CD playing";
  }
}
//---------------------------------------------------------------------------
void __fastcall CDPlay(AnsiString PlayList)
{
  //To play a range of tracks enter the PlayList as "from X to Y"
  //Where X is the starting track and Y is the finishing track
  char *Str = "";
  if (CDMode == cdStoped) {
    if (PlayList.Length() > 0) {
      sprintf(Str, "play cdaudio %s", PlayList.c_str());
      mciSendString((LPTSTR) Str, mciReturn, lstrlen(mciReturn), NULL);
    }
    else {
      mciSendString("play cdaudio", mciReturn, lstrlen(mciReturn), NULL);
    }
    if ((DWORD) mciReturn != 0) ShowMessage("Error playing CD");
    CDMode = cdPlaying;
  }
}
//---------------------------------------------------------------------------
void __fastcall CDStop()
{
  mciSendString("stop cdaudio", mciReturn, lstrlen(mciReturn), NULL);
  if ((DWORD) mciReturn != 0) ShowMessage("Error stopping CD");
  CDMode = cdStoped;
  CommReturn = "CD stopped";
}
//---------------------------------------------------------------------------
AnsiString CDTracks()
{
  AnsiString Ret;
  DWORD Err;
  Err = mciSendString("status cdaudio time format", mciReturn,
   lstrlen(mciReturn), NULL);
  if (Err != 0) ShowMessage("ERROR");
  ShowMessage(mciReturn);
  Ret = IntToStr((int)mciReturn);
  return Ret;
}
//---------------------------------------------------------------------------
AnsiString Exec_CDComm(AnsiString Comm)
{
  CommReturn = "";
  if (Comm == "CLOSE") CDClose();
  else if (Comm == "EJECT") CDEject();
  else if (Comm == "INIT") CDInit();
  else if (Comm == "INJECT") CDInject();
  else if (Comm == "PAUSE") CDPause();
  else if (Comm == "STOP") CDStop();
  else if (Comm == "TRACKS") CommReturn = CDTracks();
  else CommReturn = "Unknown command";
  return CommReturn;
}
//---------------------------------------------------------------------------
};