//---------------------------------------------------------------------------
#ifndef E7_SoundH
#define E7_SoundH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <mmsystem.h>
#include <dsound.h>
//---------------------------------------------------------------------------
class PACKAGE TE7_Sound : public TComponent
{
  private:
    DWORD FBufferBytes;
    LPDIRECTSOUND FDirectSound;
    LPDIRECTSOUNDBUFFER FDSBuffer;
    LPDIRECTSOUNDNOTIFY FDSNotify;
    AnsiString FFileName;
    HANDLE FHandle;
    
    WAVEFORMATEX* Fpwfx;        // Pointer to WAVEFORMATEX structure
    HMMIO         FhmmioIn;     // MM I/O handle for the WAVE
    MMCKINFO      FckIn;        // Multimedia RIFF chunk
    MMCKINFO      FckInRiff;    // Use in opening a WAVE file

    void CreateStaticBuffer(AnsiString F_Name);
    HRESULT FillBuffer();
    HRESULT Open(AnsiString FName);
    HRESULT Read(UINT nSizeToRead, Byte* pbData, UINT* pnSizeRead);

    HRESULT Close();
    HRESULT ReadMMIO(HMMIO hmmioIn, MMCKINFO* pckInRIFF, WAVEFORMATEX** ppwfxInfo);
    HRESULT WaveOpenFile( CHAR* FileName, HMMIO* phmmioIn,
     WAVEFORMATEX** ppwfxInfo, MMCKINFO* pckInRIFF);
    HRESULT WaveReadFile(HMMIO hmmioIn, UINT cbRead, BYTE* pbDest,
     MMCKINFO* pckIn, UINT* cbActualRead);
    HRESULT WaveStartDataRead(HMMIO* phmmioIn, MMCKINFO* pckIn,
     MMCKINFO* pckInRIFF);

  protected:
    DWORD GetStatus();
    HRESULT Reset();
    HRESULT RestoreBuffer();

  public:
    __property LPDIRECTSOUND ADirectSound = {read=FDirectSound};

    __fastcall TE7_Sound(TComponent* Owner);
    __fastcall ~TE7_Sound(void);
    void __fastcall FreeDirectSound();
    void __fastcall Init();
    void __fastcall LoadWaveFile(AnsiString F_Name);
    void __fastcall PlayBuffer(bool Looped);
    void __fastcall StopBuffer();

  __published:
};
//---------------------------------------------------------------------------
#endif
